/* Generated by Edge Impulse
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
// Generated on: 26.03.2022 15:03:38

#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include "edge-impulse-sdk/tensorflow/lite/c/builtin_op_data.h"
#include "edge-impulse-sdk/tensorflow/lite/c/common.h"
#include "edge-impulse-sdk/tensorflow/lite/micro/micro_mutable_op_resolver.h"
#include "edge-impulse-sdk/porting/ei_classifier_porting.h"

#if EI_CLASSIFIER_PRINT_STATE
#if defined(__cplusplus) && EI_C_LINKAGE == 1
extern "C" {
    extern void ei_printf(const char *format, ...);
}
#else
extern void ei_printf(const char *format, ...);
#endif
#endif

#if defined __GNUC__
#define ALIGN(X) __attribute__((aligned(X)))
#elif defined _MSC_VER
#define ALIGN(X) __declspec(align(X))
#elif defined __TASKING__
#define ALIGN(X) __align(X)
#endif

using namespace tflite;
using namespace tflite::ops;
using namespace tflite::ops::micro;

namespace {

constexpr int kTensorArenaSize = 237280;

#if defined(EI_CLASSIFIER_ALLOCATION_STATIC)
uint8_t tensor_arena[kTensorArenaSize] ALIGN(16);
#elif defined(EI_CLASSIFIER_ALLOCATION_STATIC_HIMAX)
#pragma Bss(".tensor_arena")
uint8_t tensor_arena[kTensorArenaSize] ALIGN(16);
#pragma Bss()
#elif defined(EI_CLASSIFIER_ALLOCATION_STATIC_HIMAX_GNU)
uint8_t tensor_arena[kTensorArenaSize] ALIGN(16) __attribute__((section(".tensor_arena")));
#else
#define EI_CLASSIFIER_ALLOCATION_HEAP 1
uint8_t* tensor_arena = NULL;
#endif

static uint8_t* tensor_boundary;
static uint8_t* current_location;

template <int SZ, class T> struct TfArray {
  int sz; T elem[SZ];
};
enum used_operators_e {
  OP_CONV_2D, OP_DEPTHWISE_CONV_2D, OP_ADD, OP_PAD, OP_SOFTMAX,  OP_LAST
};
struct TensorInfo_t { // subset of TfLiteTensor used for initialization from constant memory
  TfLiteAllocationType allocation_type;
  TfLiteType type;
  void* data;
  TfLiteIntArray* dims;
  size_t bytes;
  TfLiteQuantization quantization;
};
struct NodeInfo_t { // subset of TfLiteNode used for initialization from constant memory
  struct TfLiteIntArray* inputs;
  struct TfLiteIntArray* outputs;
  void* builtin_data;
  used_operators_e used_op_index;
};

TfLiteContext ctx{};
TfLiteTensor tflTensors[72];
TfLiteEvalTensor tflEvalTensors[72];
TfLiteRegistration registrations[OP_LAST];
TfLiteNode tflNodes[28];

const TfArray<4, int> tensor_dimension0 = { 4, { 1,96,96,1 } };
const TfArray<1, float> quant0_scale = { 1, { 0.0039215688593685627, } };
const TfArray<1, int> quant0_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant0 = { (TfLiteFloatArray*)&quant0_scale, (TfLiteIntArray*)&quant0_zero, 0 };
const ALIGN(16) int32_t tensor_data1[4*2] = { 
  0, 0, 
  0, 1, 
  0, 1, 
  0, 0, 
};
const TfArray<2, int> tensor_dimension1 = { 2, { 4,2 } };
const ALIGN(16) int8_t tensor_data2[8*3*3*1] = { 
  /* [0][0][][] */ -56, 51, 9, 
  /* [0][1][][] */ -127, 122, 0, 
  /* [0][2][][] */ -42, 46, 0, 
  /* [1][0][][] */ 58, 127, 35, 
  /* [1][1][][] */ -67, -79, -44, 
  /* [1][2][][] */ 8, -41, 5, 
  /* [2][0][][] */ 31, 28, -46, 
  /* [2][1][][] */ 52, 70, -127, 
  /* [2][2][][] */ 21, 33, -58, 
  /* [3][0][][] */ 45, 55, 21, 
  /* [3][1][][] */ 56, 77, 28, 
  /* [3][2][][] */ -79, -127, -57, 
  /* [4][0][][] */ 4, -53, 48, 
  /* [4][1][][] */ 16, -127, 113, 
  /* [4][2][][] */ 4, -37, 32, 
  /* [5][0][][] */ 3, -55, 1, 
  /* [5][1][][] */ 1, 127, 3, 
  /* [5][2][][] */ 2, -74, 1, 
  /* [6][0][][] */ -24, -101, -5, 
  /* [6][1][][] */ -31, -127, -3, 
  /* [6][2][][] */ -10, -49, -3, 
  /* [7][0][][] */ 39, -127, 19, 
  /* [7][1][][] */ -20, -11, -22, 
  /* [7][2][][] */ -23, 59, -25, 
};
const TfArray<4, int> tensor_dimension2 = { 4, { 8,3,3,1 } };
const TfArray<8, float> quant2_scale = { 8, { 0.055961426347494125, 0.06959659606218338, 0.046320289373397827, 0.029323799535632133, 0.075405880808830261, 0.087226256728172302, 0.0028640930540859699, 0.0073708514682948589, } };
const TfArray<8, int> quant2_zero = { 8, { 0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant2 = { (TfLiteFloatArray*)&quant2_scale, (TfLiteIntArray*)&quant2_zero, 0 };
const ALIGN(16) int32_t tensor_data3[8] = { 11445, 7001, -110, 21126, 2502, 5846, 99694, 11236, };
const TfArray<1, int> tensor_dimension3 = { 1, { 8 } };
const TfArray<8, float> quant3_scale = { 8, { 0.00021945658954791725, 0.0002729278348851949, 0.00018164821085520089, 0.00011499530228320509, 0.00029570935294032097, 0.00034206378040835261, 1.1231738426431548e-05, 2.8905302315251902e-05, } };
const TfArray<8, int> quant3_zero = { 8, { 0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant3 = { (TfLiteFloatArray*)&quant3_scale, (TfLiteIntArray*)&quant3_zero, 0 };
const ALIGN(16) int8_t tensor_data4[1*3*3*8] = { 
  /* [0][0][][] */ 10,0,10,22,6,-2,8,35, 8,2,-41,127,-15,-6,-5,31, -4,-2,-4,7,-6,-4,-6,20, 
  /* [0][1][][] */ 6,1,127,-18,127,5,-113,44, 127,-127,-91,8,-84,127,-15,-127, -25,0,27,-22,-13,2,127,40, 
  /* [0][2][][] */ 12,-6,11,-3,9,4,16,34, 0,4,-33,-2,-13,-5,-10,-105, -4,-3,7,3,-22,-2,-6,36, 
};
const TfArray<4, int> tensor_dimension4 = { 4, { 1,3,3,8 } };
const TfArray<8, float> quant4_scale = { 8, { 0.011895707808434963, 0.015339585952460766, 0.010944672860205173, 0.015241322107613087, 0.013320199213922024, 0.014742872677743435, 0.050839312374591827, 0.088645376265048981, } };
const TfArray<8, int> quant4_zero = { 8, { 0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant4 = { (TfLiteFloatArray*)&quant4_scale, (TfLiteIntArray*)&quant4_zero, 3 };
const ALIGN(16) int32_t tensor_data5[8] = { -13492, 11236, -531, -12457, 55, -12390, 429, 178, };
const TfArray<1, int> tensor_dimension5 = { 1, { 8 } };
const TfArray<8, float> quant5_scale = { 8, { 0.00027989901718683541, 0.00036093144444748759, 0.00025752172223292291, 0.0003586193488445133, 0.00031341647263616323, 0.00034689111635088921, 0.0011962191201746464, 0.0020857735071331263, } };
const TfArray<8, int> quant5_zero = { 8, { 0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant5 = { (TfLiteFloatArray*)&quant5_scale, (TfLiteIntArray*)&quant5_zero, 0 };
const ALIGN(16) int8_t tensor_data6[8*1*1*8] = { 
  /* [0][0][][] */ -33,-3,-61,-38,-26,38,-127,-10, 
  /* [1][0][][] */ 15,85,-1,127,9,0,-7,-39, 
  /* [2][0][][] */ 127,-9,-18,-57,-65,44,102,-60, 
  /* [3][0][][] */ 1,-127,41,-88,11,-71,17,53, 
  /* [4][0][][] */ 126,-12,-54,2,40,3,-127,-46, 
  /* [5][0][][] */ 3,-37,7,34,4,-127,2,7, 
  /* [6][0][][] */ 123,-32,127,8,122,-36,11,-5, 
  /* [7][0][][] */ -127,-7,-94,-1,-105,4,37,-6, 
};
const TfArray<4, int> tensor_dimension6 = { 4, { 8,1,1,8 } };
const TfArray<8, float> quant6_scale = { 8, { 0.0028203991241753101, 0.0056638247333467007, 0.003933704923838377, 0.0025135837495326996, 0.0051582991145551205, 0.008498581126332283, 0.003738755127415061, 0.0073598176240921021, } };
const TfArray<8, int> quant6_zero = { 8, { 0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant6 = { (TfLiteFloatArray*)&quant6_scale, (TfLiteIntArray*)&quant6_zero, 0 };
const ALIGN(16) int32_t tensor_data7[8] = { 4760, -4575, -516, 3557, 1395, 1185, -3545, 3754, };
const TfArray<1, int> tensor_dimension7 = { 1, { 8 } };
const TfArray<8, float> quant7_scale = { 8, { 6.6362335928715765e-05, 0.00013326646876521409, 9.2557762400247157e-05, 5.9143148973817006e-05, 0.00012137174780946225, 0.00019996661285404116, 8.7970707681961358e-05, 0.0001731721858959645, } };
const TfArray<8, int> quant7_zero = { 8, { 0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant7 = { (TfLiteFloatArray*)&quant7_scale, (TfLiteIntArray*)&quant7_zero, 0 };
const ALIGN(16) int8_t tensor_data8[48*1*1*8] = { 
  /* [0][0][][] */ -109,-100,28,-127,-62,-4,-23,8, 
  /* [1][0][][] */ -127,-18,85,-7,-64,19,12,17, 
  /* [2][0][][] */ 1,-18,39,127,16,-27,-33,8, 
  /* [3][0][][] */ -112,-59,-17,-11,33,127,-42,-42, 
  /* [4][0][][] */ -3,-30,-11,4,-11,7,-127,-70, 
  /* [5][0][][] */ 8,-40,-18,-8,-11,20,-127,-62, 
  /* [6][0][][] */ 127,11,19,-14,-74,14,5,-7, 
  /* [7][0][][] */ -127,-26,-3,1,66,-3,8,0, 
  /* [8][0][][] */ 19,59,-17,-22,-26,-127,49,12, 
  /* [9][0][][] */ 78,34,-16,6,-30,12,-7,127, 
  /* [10][0][][] */ 127,-30,-121,-5,-86,-19,41,127, 
  /* [11][0][][] */ -127,86,-24,-6,57,-55,-4,40, 
  /* [12][0][][] */ 122,-33,-127,14,70,-2,-2,-32, 
  /* [13][0][][] */ 127,-8,12,-27,-24,21,9,-12, 
  /* [14][0][][] */ -127,-69,96,-33,59,-39,-36,-118, 
  /* [15][0][][] */ 31,63,6,-13,-3,-127,-9,13, 
  /* [16][0][][] */ -9,-74,11,1,16,127,18,7, 
  /* [17][0][][] */ 18,-127,-58,13,-29,111,-70,11, 
  /* [18][0][][] */ 25,-21,-17,-21,-20,12,127,-10, 
  /* [19][0][][] */ -5,22,-3,-127,-9,28,0,-13, 
  /* [20][0][][] */ -65,-22,52,5,50,80,-10,-127, 
  /* [21][0][][] */ -7,-19,34,-26,-3,19,-127,-86, 
  /* [22][0][][] */ 65,-14,6,127,-30,-34,39,51, 
  /* [23][0][][] */ 127,-39,-116,-22,4,-39,-9,14, 
  /* [24][0][][] */ -32,21,17,24,15,-11,-127,-91, 
  /* [25][0][][] */ 127,16,-93,10,12,-7,5,28, 
  /* [26][0][][] */ 1,60,-25,-127,-28,24,5,1, 
  /* [27][0][][] */ 127,4,-107,-37,-91,14,35,74, 
  /* [28][0][][] */ -127,-18,-18,7,44,2,9,15, 
  /* [29][0][][] */ -6,-127,-31,-114,-13,37,-23,-5, 
  /* [30][0][][] */ -12,108,123,88,53,-127,127,64, 
  /* [31][0][][] */ -67,-8,-127,42,2,-21,92,104, 
  /* [32][0][][] */ 0,-118,-2,-127,-3,8,0,-24, 
  /* [33][0][][] */ 1,-121,9,-127,4,8,1,-26, 
  /* [34][0][][] */ -35,-46,29,-118,33,-55,127,81, 
  /* [35][0][][] */ -127,8,63,-1,-115,-29,39,123, 
  /* [36][0][][] */ -127,-5,99,-30,-61,-13,-33,32, 
  /* [37][0][][] */ 127,10,2,-7,-76,16,-2,14, 
  /* [38][0][][] */ -71,7,98,39,92,-41,76,127, 
  /* [39][0][][] */ -127,-4,72,-19,-59,-3,4,-10, 
  /* [40][0][][] */ -3,21,36,-1,7,-7,127,37, 
  /* [41][0][][] */ 127,-9,-75,-2,68,14,10,-12, 
  /* [42][0][][] */ -11,-127,28,-11,18,4,-10,-17, 
  /* [43][0][][] */ 5,127,101,5,33,-58,73,8, 
  /* [44][0][][] */ 12,-17,-16,105,4,-127,2,5, 
  /* [45][0][][] */ 127,-29,46,-9,-67,112,11,-1, 
  /* [46][0][][] */ 11,124,-24,81,8,127,21,42, 
  /* [47][0][][] */ -11,56,26,-20,30,-45,127,69, 
};
const TfArray<4, int> tensor_dimension8 = { 4, { 48,1,1,8 } };
const TfArray<48, float> quant8_scale = { 48, { 0.0043146787211298943, 0.0069381352514028549, 0.00098302715923637152, 0.011395166628062725, 0.0049527101218700409, 0.0059084780514240265, 0.022632762789726257, 0.016050919890403748, 0.012258687056601048, 0.007298668846487999, 0.0019531799480319023, 0.0055314330384135246, 0.0052207387052476406, 0.014238921925425529, 0.0077218255028128624, 0.022357655689120293, 0.010493572801351547, 0.0035441173240542412, 0.016008295118808746, 0.020790651440620422, 0.010930603370070457, 0.0049150832928717136, 0.0016929202247411013, 0.0061727352440357208, 0.01464549545198679, 0.010574574582278728, 0.010796532966196537, 0.0059527852572500706, 0.016493074595928192, 0.0070765158161520958, 0.003043151693418622, 0.0067430487833917141, 0.0085414042696356773, 0.0029335734434425831, 0.0025181449018418789, 0.0043189548887312412, 0.0070370407775044441, 0.018154211342334747, 0.006857734639197588, 0.0088667646050453186, 0.017523335292935371, 0.0067657823674380779, 0.0083406688645482063, 0.0031541332136839628, 0.017981519922614098, 0.0068043372593820095, 0.0074775302782654762, 0.0054757068865001202, } };
const TfArray<48, int> quant8_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant8 = { (TfLiteFloatArray*)&quant8_scale, (TfLiteIntArray*)&quant8_zero, 0 };
const ALIGN(16) int32_t tensor_data9[48] = { 10714, 5231, 16479, 1899, 4414, 3605, -3966, 4455, 2465, -3643, -1435, 4725, -3238, -3616, 8165, 2104, -1684, 3059, -862, 3289, 321, 4177, 1524, -655, 689, -4824, 2265, -1499, 4009, 6933, -138, 91, 6991, 11587, 11742, 4867, 7665, -4360, -449, 5349, -1180, -4621, 3946, -160, 574, -6822, -10459, 1091, };
const TfArray<1, int> tensor_dimension9 = { 1, { 48 } };
const TfArray<48, float> quant9_scale = { 48, { 0.00034718835377134383, 0.00055828946642577648, 7.9101038863882422e-05, 0.0009169324766844511, 0.00039852870395407081, 0.00047543627442792058, 0.0018211858114227653, 0.0012915660627186298, 0.00098641717340797186, 0.0005873004556633532, 0.00015716612688265741, 0.00044509666622616351, 0.00042009609751403332, 0.0011457604123279452, 0.00062135054031386971, 0.0017990488559007645, 0.00084438413614407182, 0.00028518374892883003, 0.0012881361180916429, 0.001672956976108253, 0.00087955058552324772, 0.00039550097426399589, 0.00013622385449707508, 0.00049670023145154119, 0.0011784760281443596, 0.00085090211359784007, 0.00086876237764954567, 0.00047900152276270092, 0.0013271447969600558, 0.00056942453375086188, 0.00024487264454364777, 0.00054259150056168437, 0.00068729941267520189, 0.00023605524620506912, 0.00020262703765183687, 0.00034753244835883379, 0.00056624808348715305, 0.001460811123251915, 0.00055181991774588823, 0.00071348011260852218, 0.0014100465923547745, 0.00054442079272121191, 0.0006711468449793756, 0.00025380298029631376, 0.0014469152083620429, 0.00054752320284023881, 0.00060169288190081716, 0.00044061258086003363, } };
const TfArray<48, int> quant9_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant9 = { (TfLiteFloatArray*)&quant9_scale, (TfLiteIntArray*)&quant9_zero, 0 };
const ALIGN(16) int8_t tensor_data10[1*3*3*48] = { 
  /* [0][0][][] */ -15,-84,-116,76,-81,0,-58,-105,59,47,92,-43,-6,14,-81,-37,98,-108,53,-32,-74,-102,-54,-86,91,69,-3,-117,-3,-38,56,67,43,103,45,9,87,47,88,-9,-127,-30,13,55,-99,-5,-52,-90, 85,1,10,67,-127,42,-87,21,94,106,18,43,-10,-82,-108,-127,127,-41,80,-97,-127,125,127,53,99,67,34,-89,-70,-64,-110,88,90,123,105,103,-16,116,45,-72,-97,-97,8,-65,-109,111,-127,115, 127,14,37,70,-68,5,-40,-9,9,40,-28,-19,-92,-19,-29,-42,69,68,55,-36,-61,-40,-103,62,80,1,30,-40,-16,-34,21,41,58,113,28,55,-20,24,-1,-12,-91,-17,-29,11,-71,53,-26,6, 
  /* [0][1][][] */ 43,-127,105,106,82,-85,-127,-127,127,44,127,-62,5,-23,-105,-54,111,127,43,-74,-73,103,59,-127,127,113,98,-127,-1,-89,-72,70,107,-8,85,44,41,126,119,-20,-39,-40,82,101,-88,80,-111,115, 87,-17,-4,127,120,-127,-79,-23,98,127,76,54,-28,-127,-127,-110,82,63,127,-127,-96,-127,-109,56,86,127,127,-101,-127,-122,127,127,127,9,127,127,7,127,127,-127,-13,-127,109,-103,-82,127,-125,-127, 95,1,-127,83,89,-66,-65,-33,32,55,1,-35,-127,-28,-24,-71,46,-114,56,-23,-45,-2,73,55,104,21,14,-34,-26,-82,-29,27,69,9,46,60,-10,15,49,-6,-53,-18,59,-12,-64,39,-41,18, 
  /* [0][2][][] */ 43,-67,5,45,-11,49,-116,-94,14,27,79,53,15,-7,-69,0,12,-49,33,-65,-16,-11,3,-80,26,16,68,-16,7,-127,14,10,57,-119,102,25,-127,19,64,-20,6,-30,107,-127,-84,61,-56,-2, 39,4,-8,70,0,83,8,-39,-6,87,43,-127,-7,-110,-41,-12,31,-27,30,-94,-11,-18,-35,49,21,32,45,-29,-94,-116,-27,-17,45,-127,112,36,35,56,47,-52,114,-79,127,106,-127,56,-97,13, 2,-6,-12,61,-26,36,-12,-44,-26,83,-8,42,-64,-23,15,10,-1,18,17,-35,-78,-1,11,26,29,16,10,-17,-9,-39,12,-54,-2,-64,47,9,0,-21,18,-1,32,6,26,1,-58,-9,-28,-7, 
};
const TfArray<4, int> tensor_dimension10 = { 4, { 1,3,3,48 } };
const TfArray<48, float> quant10_scale = { 48, { 0.0051338919438421726, 0.0062267361208796501, 0.026592161506414413, 0.0020190950017422438, 0.018958728760480881, 0.025893175974488258, 0.0071926219388842583, 0.0046380152925848961, 0.0031641465611755848, 0.0052183377556502819, 0.01555472519248724, 0.010533441789448261, 0.0078143812716007233, 0.006593422032892704, 0.0024875765666365623, 0.0027997775468975306, 0.0046830205246806145, 0.019546870142221451, 0.0027670350391417742, 0.0039564338512718678, 0.0023107179440557957, 0.024556377902626991, 0.04061257466673851, 0.013164295814931393, 0.0022779840510338545, 0.0067016538232564926, 0.0043352036736905575, 0.0053106853738427162, 0.0049886233173310757, 0.0059460438787937164, 0.022350721061229706, 0.01121701393276453, 0.0033314691390842199, 0.0078272232785820961, 0.0036802219692617655, 0.0030871923081576824, 0.01149329636245966, 0.014328758232295513, 0.0038724932819604874, 0.0063971667550504208, 0.0029432591982185841, 0.0078814607113599777, 0.0043117301538586617, 0.015391047112643719, 0.0041722566820681095, 0.012705408036708832, 0.0033809193409979343, 0.020835429430007935, } };
const TfArray<48, int> quant10_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant10 = { (TfLiteFloatArray*)&quant10_scale, (TfLiteIntArray*)&quant10_zero, 3 };
const ALIGN(16) int32_t tensor_data11[48] = { 925, 8398, 7119, 6357, 769, 1720, 7366, 10267, 833, -12191, -580, 1601, 7042, 7051, 22385, 16134, -1170, 1717, 1284, 7105, 18321, 2875, 900, -541, 2854, 233, 4462, 17828, 6332, 13977, -180, 2552, -1103, -1501, -11069, 1136, -375, -61, 107, 5233, 10705, 5186, -6258, 935, 9915, 360, 13417, -1545, };
const TfArray<1, int> tensor_dimension11 = { 1, { 48 } };
const TfArray<48, float> quant11_scale = { 48, { 0.00012079745647497475, 0.00014651144738309085, 0.00062569795409217477, 4.7508117859251797e-05, 0.00044608773896470666, 0.00060925120487809181, 0.0001692381629254669, 0.00010912977450061589, 7.4450508691370487e-05, 0.00012278441863600165, 0.0003659935318864882, 0.00024784568813629448, 0.00018386779993306845, 0.0001551393506815657, 5.853121547261253e-05, 6.5877116867341101e-05, 0.00011018871737178415, 0.00045992637751623988, 6.5106709371320903e-05, 9.3092559836804867e-05, 5.4369833378586918e-05, 0.00057779712369665504, 0.00095558998873457313, 0.00030974813853390515, 5.359962597140111e-05, 0.00015768597950227559, 0.00010200479300692677, 0.00012495731061790138, 0.00011737937165889889, 0.00013990691513754427, 0.00052589934784919024, 0.00026392974541522563, 7.8387507528532296e-05, 0.00018416995590087026, 8.6593456217087805e-05, 7.2639821155462414e-05, 0.00027043049340136349, 0.00033714727032929659, 9.1117493866477162e-05, 0.00015052157687023282, 6.9253161200322211e-05, 0.00018544614431448281, 0.00010145247506443411, 0.00036214228020980954, 9.8170748970005661e-05, 0.00029895079205743968, 7.9551042290404439e-05, 0.00049024540930986404, } };
const TfArray<48, int> quant11_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant11 = { (TfLiteFloatArray*)&quant11_scale, (TfLiteIntArray*)&quant11_zero, 0 };
const ALIGN(16) int8_t tensor_data12[8*1*1*48] = { 
  /* [0][0][][] */ 57,124,-52,73,-4,3,-17,8,69,-74,-9,-31,6,8,-51,-59,-8,-20,35,11,-68,-33,-35,5,23,21,36,15,17,14,-19,28,-59,10,115,-127,-20,8,-16,114,-33,-1,14,2,-16,30,12,-35, 
  /* [1][0][][] */ -4,-50,41,43,-20,-13,-24,-28,37,-37,108,28,19,35,-41,-94,127,36,23,9,-62,27,24,-7,-58,-97,-43,-73,-17,-78,47,-54,-3,-33,-9,9,-3,-10,90,-49,-16,48,-50,29,74,69,36,39, 
  /* [2][0][][] */ 89,-13,-21,-13,97,113,76,83,-45,8,10,-37,1,45,68,33,-17,-37,48,-47,-25,-53,-51,51,-109,-94,112,22,53,-59,-80,12,-127,68,108,26,-20,-9,-3,25,29,64,9,-70,2,8,54,-36, 
  /* [3][0][][] */ 67,-41,24,-8,97,127,15,38,-25,-47,18,45,-115,40,60,24,10,1,67,-92,-88,7,43,94,11,-38,52,26,50,-44,22,-6,-95,81,-56,-107,21,-32,58,-49,37,-82,-87,-17,-59,38,-13,48, 
  /* [4][0][][] */ 32,38,-35,-30,-18,-12,-29,-14,-6,-4,0,-10,-33,-24,68,48,-37,-17,-34,36,36,-14,-14,0,-51,-39,-10,39,-12,10,-19,13,-31,-20,20,-127,-12,36,3,56,9,-10,-21,-16,31,9,90,-29, 
  /* [5][0][][] */ 48,48,-82,46,-2,6,-6,18,-72,-34,-43,-23,34,32,41,33,39,-59,42,127,-52,-39,-52,48,22,-20,-41,44,18,31,-44,-4,-17,-4,-54,-4,-3,23,-15,55,14,74,-12,-37,121,35,18,-61, 
  /* [6][0][][] */ -29,-70,25,-44,-44,-40,-83,-80,-38,-66,-122,34,-55,-52,88,87,-127,9,19,-32,0,63,67,11,-6,-16,-66,93,-77,-40,47,71,14,-53,86,40,23,41,-5,-88,-13,-66,-31,13,-51,-8,-16,70, 
  /* [7][0][][] */ 86,16,-5,50,19,12,16,0,94,-12,-28,-9,60,-6,-22,-13,-50,1,-22,3,-7,-17,-13,-17,89,-127,20,22,13,99,-16,21,-70,38,-67,-38,-14,20,38,24,29,57,-24,-12,-54,33,44,-14, 
};
const TfArray<4, int> tensor_dimension12 = { 4, { 8,1,1,48 } };
const TfArray<8, float> quant12_scale = { 8, { 0.0051121902652084827, 0.0043563079088926315, 0.0034398604184389114, 0.0027114204131066799, 0.0060656173154711723, 0.0044265626929700375, 0.0046046283096075058, 0.0044851689599454403, } };
const TfArray<8, int> quant12_zero = { 8, { 0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant12 = { (TfLiteFloatArray*)&quant12_scale, (TfLiteIntArray*)&quant12_zero, 0 };
const ALIGN(16) int32_t tensor_data13[8] = { -12526, 200, -17966, 122, 3591, -2949, 12311, -1968, };
const TfArray<1, int> tensor_dimension13 = { 1, { 8 } };
const TfArray<8, float> quant13_scale = { 8, { 0.00012028682976961136, 0.00010250136256217957, 8.0937890743371099e-05, 6.3798128394410014e-05, 0.00014272041153162718, 0.00010415441647637635, 0.00010834419663297012, 0.00010553339234320447, } };
const TfArray<8, int> quant13_zero = { 8, { 0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant13 = { (TfLiteFloatArray*)&quant13_scale, (TfLiteIntArray*)&quant13_zero, 0 };
const ALIGN(16) int8_t tensor_data14[48*1*1*8] = { 
  /* [0][0][][] */ -32,13,13,-127,-105,6,44,126, 
  /* [1][0][][] */ 102,29,1,31,-76,74,127,20, 
  /* [2][0][][] */ 12,82,-31,-32,-5,59,-56,-127, 
  /* [3][0][][] */ 33,-86,-49,127,-81,-61,0,-9, 
  /* [4][0][][] */ 27,-70,45,3,-127,-31,59,38, 
  /* [5][0][][] */ -15,47,-11,-87,-127,-7,-30,1, 
  /* [6][0][][] */ 41,-10,7,36,106,-18,6,-127, 
  /* [7][0][][] */ 21,41,19,127,23,-1,-2,17, 
  /* [8][0][][] */ 21,50,22,-27,66,127,23,-46, 
  /* [9][0][][] */ 122,-10,-9,45,-38,-93,104,127, 
  /* [10][0][][] */ 12,78,-77,-20,4,127,90,-62, 
  /* [11][0][][] */ -11,-40,-113,127,-75,17,9,97, 
  /* [12][0][][] */ -93,-110,46,53,47,-127,-42,13, 
  /* [13][0][][] */ 39,37,29,44,-51,127,16,-35, 
  /* [14][0][][] */ 28,-127,-31,27,-65,-111,-87,113, 
  /* [15][0][][] */ -98,23,-33,-6,114,-6,-127,-39, 
  /* [16][0][][] */ 88,93,-94,-107,65,105,127,36, 
  /* [17][0][][] */ -95,127,-122,58,-19,-41,49,-120, 
  /* [18][0][][] */ 42,-10,-98,127,-4,-36,-53,-73, 
  /* [19][0][][] */ 94,10,-24,33,-94,28,127,73, 
  /* [20][0][][] */ 48,-54,-99,127,24,-31,-21,-68, 
  /* [21][0][][] */ 16,58,110,-127,53,-42,10,-118, 
  /* [22][0][][] */ -63,-35,-95,51,-44,28,-23,127, 
  /* [23][0][][] */ 82,25,38,50,-127,79,48,-28, 
  /* [24][0][][] */ -34,27,-127,62,-26,34,34,55, 
  /* [25][0][][] */ 50,-39,-45,127,21,-3,-47,8, 
  /* [26][0][][] */ -65,44,127,-80,-4,31,60,-1, 
  /* [27][0][][] */ -56,79,127,-7,30,-3,64,4, 
  /* [28][0][][] */ -40,-105,44,-127,-8,10,-14,-20, 
  /* [29][0][][] */ -38,-115,-60,78,4,-127,25,81, 
  /* [30][0][][] */ -127,82,90,11,23,50,114,0, 
  /* [31][0][][] */ -61,51,89,-127,-46,13,33,65, 
  /* [32][0][][] */ -47,78,75,-72,-13,-7,20,127, 
  /* [33][0][][] */ 13,94,-47,51,24,29,-127,-33, 
  /* [34][0][][] */ 82,4,127,-94,-17,-83,42,-33, 
  /* [35][0][][] */ 80,-3,58,101,117,-96,20,-127, 
  /* [36][0][][] */ 33,36,127,-88,23,-24,35,-82, 
  /* [37][0][][] */ -33,-71,97,95,17,-127,98,-3, 
  /* [38][0][][] */ 127,-43,66,28,-23,-49,126,18, 
  /* [39][0][][] */ 64,-67,-5,54,-127,8,67,83, 
  /* [40][0][][] */ -66,7,-108,126,-86,-7,-58,127, 
  /* [41][0][][] */ -84,0,-48,23,127,11,-57,2, 
  /* [42][0][][] */ -70,46,-17,-35,127,9,-80,-56, 
  /* [43][0][][] */ 126,117,-8,127,-23,-113,75,81, 
  /* [44][0][][] */ -43,33,117,-13,64,-127,-1,-58, 
  /* [45][0][][] */ -10,-71,127,74,-28,-16,-120,10, 
  /* [46][0][][] */ 35,-112,-127,98,-67,37,-12,-78, 
  /* [47][0][][] */ -115,-27,27,-20,91,46,-127,-39, 
};
const TfArray<4, int> tensor_dimension14 = { 4, { 48,1,1,8 } };
const TfArray<48, float> quant14_scale = { 48, { 0.0024247253313660622, 0.0042478106915950775, 0.0012691322481259704, 0.0036555472761392593, 0.0043961103074252605, 0.003260740777477622, 0.0040506022050976753, 0.011900539509952068, 0.0030508472118526697, 0.0034232200123369694, 0.0024206950329244137, 0.0035012380685657263, 0.0034615984186530113, 0.0047207195311784744, 0.0028395082335919142, 0.0025129877030849457, 0.0028295912779867649, 0.0035747047513723373, 0.0057811131700873375, 0.0020941204857081175, 0.0048187985084950924, 0.0040652528405189514, 0.005218330305069685, 0.0019160677911713719, 0.00054721598280593753, 0.0038621476851403713, 0.0033342442475259304, 0.0045424699783325195, 0.0091580403968691826, 0.0020416390616446733, 0.0017998290713876486, 0.0017570708878338337, 0.0018065056065097451, 0.0028716656379401684, 0.0030525843612849712, 0.0038497496861964464, 0.0055840532295405865, 0.003734236117452383, 0.0019798572175204754, 0.0015406378079205751, 0.0027587767690420151, 0.0013581197708845139, 0.0015681429067626595, 0.0022099942434579134, 0.0027522114105522633, 0.0057156677357852459, 0.0024266266264021397, 0.003370962105691433, } };
const TfArray<48, int> quant14_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant14 = { (TfLiteFloatArray*)&quant14_scale, (TfLiteIntArray*)&quant14_zero, 0 };
const ALIGN(16) int32_t tensor_data15[48] = { 7530, 2229, 19669, -2478, -1474, 7274, -1253, 768, 4934, -65, 7262, 1367, 4092, 3474, 3903, 7011, 4622, 3013, -1043, 8628, 1749, 568, 341, 11014, 62890, 4626, 5194, -2179, 68, 8786, 10547, 11863, 11903, 6832, 6530, -817, 544, 2177, 9097, 12505, 2709, 16674, 14748, 7753, 6304, 2203, 7701, 1119, };
const TfArray<1, int> tensor_dimension15 = { 1, { 48 } };
const TfArray<48, float> quant15_scale = { 48, { 0.0001156428552349098, 0.00020259158918634057, 6.0528949688887224e-05, 0.00017434466280974448, 0.00020966447482351214, 0.00015551509568467736, 0.00019318608974572271, 0.00056757457787171006, 0.00014550460036844015, 0.00016326423792634159, 0.0001154506389866583, 0.00016698517720215023, 0.00016509463603142649, 0.00022514611191581935, 0.00013542517262976617, 0.00011985236778855324, 0.00013495220628101379, 0.00017048903100658208, 0.00027571964892558753, 9.9875258456449956e-05, 0.00022982381051406264, 0.0001938848290592432, 0.0002488787577021867, 9.1383364633657038e-05, 2.6098468879354186e-05, 0.00018419809930492193, 0.00015902071027085185, 0.00021664482483174652, 0.00043677605572156608, 9.7372256277594715e-05, 8.5839565144851804e-05, 8.3800296124536544e-05, 8.6157990153878927e-05, 0.00013695885718334466, 0.00014558744442183524, 0.00018360679678153247, 0.00026632123626768589, 0.00017809758719522506, 9.4425682618748397e-05, 7.347791688516736e-05, 0.0001315748377237469, 6.477304850704968e-05, 7.4789721111301333e-05, 0.00010540164657868445, 0.0001312617096118629, 0.00027259835042059422, 0.00011573353549465537, 0.00016077190230134875, } };
const TfArray<48, int> quant15_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant15 = { (TfLiteFloatArray*)&quant15_scale, (TfLiteIntArray*)&quant15_zero, 0 };
const ALIGN(16) int8_t tensor_data16[1*3*3*48] = { 
  /* [0][0][][] */ -4,-55,45,-9,127,-25,-6,-4,-29,57,-9,15,48,9,127,-42,15,-62,-34,-11,-37,-22,-51,28,-127,35,20,-1,-22,42,-22,-10,-41,27,23,4,79,1,18,-13,73,22,-13,1,-87,4,-74,-40, 13,-106,-81,-2,-39,-17,37,52,15,4,58,127,-33,58,-78,127,16,-65,41,-51,-73,-127,-80,80,-127,-68,1,97,14,36,127,2,-127,-85,-43,58,127,-96,105,8,65,-9,-23,-12,-65,-1,70,14, 14,-34,-12,127,56,2,-87,8,-23,-40,-34,-12,39,-5,-82,-45,17,46,17,-6,15,-1,-33,20,-85,-62,-20,15,15,43,-85,-6,0,127,17,24,-6,57,-119,-4,35,-9,-10,26,-127,-1,-62,53, 
  /* [0][1][][] */ -105,-84,127,-15,-55,-53,89,14,21,98,7,7,47,15,90,21,17,-127,76,43,72,-7,73,-44,-2,-26,46,-6,14,61,35,52,34,-100,7,127,3,19,-49,-113,11,101,-16,-78,45,-84,-82,-1, 127,-74,-87,-56,-7,-127,127,127,127,8,127,-34,-127,-9,-61,-43,127,-96,127,127,127,74,127,-127,24,-14,85,22,127,127,-122,127,41,-88,127,-93,-60,127,-89,127,-127,-127,127,-127,97,-127,127,-117, -14,-121,15,51,-36,-18,-68,-1,-10,-127,-48,32,76,5,-69,35,25,22,18,21,12,-20,42,-19,-13,6,-127,60,-97,15,72,25,-41,-28,-19,-44,48,26,127,11,30,48,-41,-3,76,-26,-63,127, 
  /* [0][2][][] */ -4,111,25,-34,53,-3,-34,-26,-33,18,-9,-4,57,14,77,-1,-15,37,-10,-39,-28,16,12,4,-17,-9,52,25,-74,-124,-25,-2,-9,24,-13,31,-65,54,6,111,5,15,1,-2,54,10,-37,-63, 8,94,-51,12,23,-24,-5,23,23,5,16,-28,24,127,-93,-76,8,0,61,-73,-59,68,-2,39,102,127,0,127,-85,-121,-22,9,105,-101,-79,9,-62,-12,-17,-121,39,-35,-51,51,72,39,1,-1, 1,127,-7,10,20,16,-76,-18,-34,-18,-18,-10,40,-1,-84,-13,6,28,-9,-21,0,7,0,1,-69,21,-38,21,17,-81,-5,7,-16,114,2,-22,-53,59,17,-7,-14,-20,3,-23,42,23,-20,29, 
};
const TfArray<4, int> tensor_dimension16 = { 4, { 1,3,3,48 } };
const TfArray<48, float> quant16_scale = { 48, { 0.015928512439131737, 0.0051904884167015553, 0.024970643222332001, 0.0080479001626372337, 0.0065483879297971725, 0.013017365708947182, 0.012308424338698387, 0.0070668593980371952, 0.015876250341534615, 0.0078021828085184097, 0.019058391451835632, 0.0097933374345302582, 0.0070778797380626202, 0.0068788193166255951, 0.0052264691330492496, 0.021001655608415604, 0.010548587888479233, 0.0039541185833513737, 0.0062834015116095543, 0.023126868531107903, 0.0099436528980731964, 0.019134212285280228, 0.0063012721948325634, 0.033911716192960739, 0.010185115970671177, 0.011654841713607311, 0.0089988596737384796, 0.012232783250510693, 0.0088885333389043808, 0.0079505164176225662, 0.016985788941383362, 0.022256940603256226, 0.018200008198618889, 0.0079941758885979652, 0.023440290242433548, 0.0066769965924322605, 0.010524826124310493, 0.0046079782769083977, 0.023980263620615005, 0.040448352694511414, 0.0094498172402381897, 0.032627351582050323, 0.026936763897538185, 0.0079505322501063347, 0.0085020624101161957, 0.0063466192223131657, 0.0084397997707128525, 0.011715943925082684, } };
const TfArray<48, int> quant16_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant16 = { (TfLiteFloatArray*)&quant16_scale, (TfLiteIntArray*)&quant16_zero, 3 };
const ALIGN(16) int32_t tensor_data17[48] = { -1338, 3746, 1211, -440, 962, 12413, -6, -3587, -5006, -156, -4670, -121, -3412, -4958, 2448, 1547, -9582, 11024, -4078, -808, -1158, 264, -2246, 421, 21180, -193, -1362, -1693, 1639, 62, 1482, -8422, 2210, 3781, -761, 7930, 352, -2517, -619, -271, -3694, 202, 2900, 6751, -3470, 6355, 4707, -1261, };
const TfArray<1, int> tensor_dimension17 = { 1, { 48 } };
const TfArray<48, float> quant17_scale = { 48, { 0.00037478853482753038, 0.00012212914589326829, 0.00058754457859322429, 0.0001893623557407409, 0.00015407972387038171, 0.00030629095272161067, 0.00028960997588001192, 0.00016627904551569372, 0.00037355883978307247, 0.00018358077795710415, 0.00044843275099992752, 0.00023043146939016879, 0.00016653834609314799, 0.00016185457934625447, 0.00012297574721742421, 0.00049415661487728357, 0.00024820206454023719, 9.3038084742147475e-05, 0.00014784473751205951, 0.00054416165221482515, 0.00023396831238642335, 0.00045021675759926438, 0.0001482652296544984, 0.00079792272299528122, 0.00023964978754520416, 0.00027423157007433474, 0.00021173787536099553, 0.00028783018933609128, 0.00020914195920340717, 0.00018707098206505179, 0.00039966561598703265, 0.0005236927536316216, 0.00042823550757020712, 0.00018809825996868312, 0.00055153627181425691, 0.00015710580919403583, 0.00024764297995716333, 0.00010842301708180457, 0.00056424149079248309, 0.00095172598958015442, 0.0002223486517323181, 0.0007677024113945663, 0.00063380622304975986, 0.0001870713458629325, 0.00020004852558486164, 0.00014933221973478794, 0.00019858352607116103, 0.00027566927019506693, } };
const TfArray<48, int> quant17_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant17 = { (TfLiteFloatArray*)&quant17_scale, (TfLiteIntArray*)&quant17_zero, 0 };
const ALIGN(16) int8_t tensor_data18[8*1*1*48] = { 
  /* [0][0][][] */ 38,-29,93,58,31,-44,15,5,-17,61,-22,23,-41,-76,55,15,-107,50,-28,67,-38,52,4,-47,-7,-40,54,-7,-24,22,-20,103,-62,-4,-45,-70,-62,-45,-42,-5,-4,61,-127,17,44,9,18,65, 
  /* [1][0][][] */ -51,-52,42,-15,-28,32,-42,-41,24,-16,-11,-41,-18,8,-8,-4,5,28,17,-30,-56,-46,-94,7,18,-30,-23,-36,31,-101,-1,-127,-14,-55,-63,-69,-47,-78,-36,10,44,-24,71,-108,-58,-7,-20,-6, 
  /* [2][0][][] */ -51,103,3,19,0,2,23,-43,57,-59,73,82,111,8,30,-53,71,-19,5,24,-16,16,4,111,-127,-38,-11,-27,2,72,-7,-85,-17,-1,-5,-54,-19,11,-26,-6,81,-76,-13,5,31,-115,-17,-31, 
  /* [3][0][][] */ 73,-2,-62,23,88,-89,4,-127,-34,10,-65,-87,-15,115,-10,40,-34,-21,-65,-60,49,91,-8,-22,97,55,53,-86,36,-92,58,-76,70,80,122,-62,-49,47,2,46,33,82,-76,15,-6,38,7,48, 
  /* [4][0][][] */ -59,70,-51,92,110,-58,33,-38,-59,-9,-68,50,-40,-17,2,-78,13,69,-34,-42,-54,37,-75,-94,4,-23,17,-28,17,-35,-26,70,-26,85,-90,-88,-71,-81,-48,6,94,-57,127,21,-11,105,-53,-77, 
  /* [5][0][][] */ 68,-8,93,-18,1,17,53,38,127,10,76,4,57,51,35,-78,-4,29,38,-55,-56,-98,15,58,12,-8,20,46,-38,-40,4,-26,-32,61,-30,66,38,-12,-46,-48,1,74,27,53,-38,-1,85,28, 
  /* [6][0][][] */ -2,-57,-37,13,24,1,-17,1,-60,-18,94,66,88,53,-22,48,95,-127,-10,-6,-18,-44,-95,7,-58,49,-32,2,-39,-65,69,-53,84,12,-88,-11,-41,14,48,12,77,-75,7,-90,-101,47,-51,35, 
  /* [7][0][][] */ -25,-23,-88,-19,15,111,13,-18,-7,-57,-111,-107,45,51,-52,-45,-23,23,103,28,-7,-63,66,1,127,-30,-67,89,-38,-16,-17,-70,-24,59,51,121,107,-51,-17,-49,-28,-8,40,-11,13,-19,12,-40, 
};
const TfArray<4, int> tensor_dimension18 = { 4, { 8,1,1,48 } };
const TfArray<8, float> quant18_scale = { 8, { 0.0058113704435527325, 0.0053810551762580872, 0.0057533411309123039, 0.0087713906541466713, 0.0046013179235160351, 0.0052390480414032936, 0.0031091098207980394, 0.0051887733861804008, } };
const TfArray<8, int> quant18_zero = { 8, { 0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant18 = { (TfLiteFloatArray*)&quant18_scale, (TfLiteIntArray*)&quant18_zero, 0 };
const ALIGN(16) int32_t tensor_data19[8] = { 10454, 18302, 6140, 2519, 5374, -9931, 6133, -8926, };
const TfArray<1, int> tensor_dimension19 = { 1, { 8 } };
const TfArray<8, float> quant19_scale = { 8, { 0.00013673813373316079, 0.00012661307118833065, 0.00013537274207919836, 0.00020638566638808697, 0.00010826630750671029, 0.00012327171862125397, 7.3155526479240507e-05, 0.00012208879343234003, } };
const TfArray<8, int> quant19_zero = { 8, { 0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant19 = { (TfLiteFloatArray*)&quant19_scale, (TfLiteIntArray*)&quant19_zero, 0 };
const ALIGN(16) int8_t tensor_data20[48*1*1*8] = { 
  /* [0][0][][] */ 39,27,-51,-18,-34,42,-127,54, 
  /* [1][0][][] */ 12,-43,-127,5,-5,-10,126,-103, 
  /* [2][0][][] */ -113,-33,-64,-33,-10,45,-127,-2, 
  /* [3][0][][] */ -41,-40,29,-20,-14,-127,-125,-27, 
  /* [4][0][][] */ -56,-127,-39,17,84,16,-40,-37, 
  /* [5][0][][] */ 86,-45,98,39,-127,58,-88,-123, 
  /* [6][0][][] */ 52,-127,-40,-14,-5,43,-44,-74, 
  /* [7][0][][] */ -27,-81,-30,-67,88,-127,-26,29, 
  /* [8][0][][] */ 60,83,62,101,36,-70,-11,127, 
  /* [9][0][][] */ -14,-49,-47,7,42,-15,127,-13, 
  /* [10][0][][] */ -29,44,-127,15,23,22,105,-95, 
  /* [11][0][][] */ -4,-43,-12,16,-127,26,2,37, 
  /* [12][0][][] */ 59,84,-24,28,-45,127,99,-9, 
  /* [13][0][][] */ -34,-22,24,-7,23,-127,-12,55, 
  /* [14][0][][] */ -95,-48,20,28,-7,62,-127,-111, 
  /* [15][0][][] */ 77,90,26,-9,-118,45,127,-66, 
  /* [16][0][][] */ 8,-42,-16,85,-6,-127,50,-110, 
  /* [17][0][][] */ -75,127,38,-7,-58,-50,-86,-79, 
  /* [18][0][][] */ 92,92,-110,-26,62,127,-91,-79, 
  /* [19][0][][] */ -23,88,-14,23,-127,27,-54,-85, 
  /* [20][0][][] */ -127,5,-3,18,44,2,108,62, 
  /* [21][0][][] */ -28,-8,57,26,-99,-95,-127,5, 
  /* [22][0][][] */ -5,-39,-34,6,-127,2,-7,51, 
  /* [23][0][][] */ 53,17,-5,-21,127,54,-94,91, 
  /* [24][0][][] */ 127,-24,-63,34,-108,10,-14,11, 
  /* [25][0][][] */ 29,-73,49,104,-67,-127,3,104, 
  /* [26][0][][] */ 20,127,39,66,112,-44,21,-37, 
  /* [27][0][][] */ -127,107,56,12,117,-33,-7,106, 
  /* [28][0][][] */ -106,-76,-66,-43,104,-127,37,-21, 
  /* [29][0][][] */ -51,-34,74,28,127,-89,-49,38, 
  /* [30][0][][] */ 127,42,-98,-110,-56,-85,-76,-66, 
  /* [31][0][][] */ 15,5,35,68,-127,0,39,2, 
  /* [32][0][][] */ 127,15,48,49,-45,-71,106,62, 
  /* [33][0][][] */ 127,0,-44,25,-112,-36,-8,45, 
  /* [34][0][][] */ 38,-14,-32,16,-52,127,7,-70, 
  /* [35][0][][] */ 123,25,-10,-36,22,-92,32,127, 
  /* [36][0][][] */ -46,-40,54,-105,-43,-20,92,-127, 
  /* [37][0][][] */ 67,-66,62,27,87,-4,45,-127, 
  /* [38][0][][] */ 56,127,-4,-35,-11,21,27,87, 
  /* [39][0][][] */ 38,-11,-90,84,-56,-69,-87,127, 
  /* [40][0][][] */ -16,-18,-8,-36,24,-127,20,52, 
  /* [41][0][][] */ -10,37,-127,-74,113,127,68,-114, 
  /* [42][0][][] */ 50,-56,-39,2,71,127,33,26, 
  /* [43][0][][] */ 16,32,-4,32,-127,-116,49,-52, 
  /* [44][0][][] */ -127,-55,-5,-17,50,46,-124,-54, 
  /* [45][0][][] */ -62,49,-55,27,39,-12,-60,127, 
  /* [46][0][][] */ -33,91,127,-26,-70,-99,-119,112, 
  /* [47][0][][] */ -90,-127,-40,-42,89,110,-98,86, 
};
const TfArray<4, int> tensor_dimension20 = { 4, { 48,1,1,8 } };
const TfArray<48, float> quant20_scale = { 48, { 0.0027228288818150759, 0.0016997463535517454, 0.0020790018606930971, 0.0023915895726531744, 0.0053396476432681084, 0.0007763017201796174, 0.0028613549657166004, 0.0031557399779558182, 0.00077131285797804594, 0.0037018158473074436, 0.0023030864540487528, 0.0028264278080314398, 0.0014789196429774165, 0.0030642682686448097, 0.0040488652884960175, 0.0018260038923472166, 0.0023838311899453402, 0.0010509438579902053, 0.0018761936808004975, 0.0045064711011946201, 0.002871211851015687, 0.0018600542098283768, 0.0030199144966900349, 0.0025352854281663895, 0.0024549304507672787, 0.0015218056505545974, 0.0020321318879723549, 0.0019157561473548412, 0.0036486287135630846, 0.0016413787379860878, 0.0010821652831509709, 0.0020397831685841084, 0.0026236928533762693, 0.0020392322912812233, 0.0035195010714232922, 0.0031149149872362614, 0.0023079905658960342, 0.0012803968274965882, 0.0035323326010257006, 0.0018382489215582609, 0.0018554845592007041, 0.0010858839377760887, 0.0033394726924598217, 0.002153794514015317, 0.0027267339173704386, 0.002854940015822649, 0.0004040711501147598, 0.002041997853666544, } };
const TfArray<48, int> quant20_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant20 = { (TfLiteFloatArray*)&quant20_scale, (TfLiteIntArray*)&quant20_zero, 0 };
const ALIGN(16) int32_t tensor_data21[48] = { -1476, 3915, 3398, -1043, -43, 10932, 2149, 705, 11728, 1198, -1069, 1406, 4761, 1341, 92, 1522, -939, 8339, -1980, -523, 1429, 2071, -169, -383, -254, 2705, -2085, -1639, -101, -2642, 8846, 3183, 945, 1843, 28, 1149, 1180, 6219, 1066, 712, 4240, -1832, 742, 1861, -1450, -1208, 24527, 2021, };
const TfArray<1, int> tensor_dimension21 = { 1, { 48 } };
const TfArray<48, float> quant21_scale = { 48, { 0.00031315578962676227, 0.00019548984710127115, 0.00023910847085062414, 0.00027505954494699836, 0.00061411922797560692, 8.9283377747051418e-05, 0.00032908783759921789, 0.00036294540041126311, 8.8709603005554527e-05, 0.0004257502150721848, 0.0002648807130753994, 0.00032507081050425768, 0.00017009230214171112, 0.00035242512240074575, 0.00046566480887122452, 0.00021001086861360818, 0.00027416725060902536, 0.00012087029608665034, 0.00021578326413873583, 0.00051829457515850663, 0.00033022149000316858, 0.00021392703638412058, 0.00034732394851744175, 0.00029158618417568505, 0.00028234446654096246, 0.00017502467380836606, 0.00023371790302917361, 0.00022033338609617203, 0.0004196331137791276, 0.00018877691763918847, 0.0001244611048605293, 0.00023459788644686341, 0.00030175401479937136, 0.0002345345274079591, 0.00040478198206983507, 0.00035825007944367826, 0.0002654447453096509, 0.00014725995424669236, 0.00040625775000080466, 0.0002114191884174943, 0.00021340147941373289, 0.00012488880020100623, 0.00038407670217566192, 0.0002477104717399925, 0.00031360489083454013, 0.00032835002639330924, 4.6472701797029004e-05, 0.00023485258861910552, } };
const TfArray<48, int> quant21_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant21 = { (TfLiteFloatArray*)&quant21_scale, (TfLiteIntArray*)&quant21_zero, 0 };
const ALIGN(16) int8_t tensor_data22[1*3*3*48] = { 
  /* [0][0][][] */ 33,-37,-22,73,97,34,-37,-87,-5,5,88,-81,-8,90,110,41,91,-84,48,51,-71,-27,44,109,-35,-18,49,95,48,86,-35,35,46,-124,-95,-82,72,-51,83,-42,-124,45,46,-77,32,67,42,-22, 0,-57,-48,124,127,20,-37,-75,17,54,127,-94,-66,84,100,127,40,-79,80,48,-26,-127,68,48,0,-81,87,120,127,127,-29,56,57,-110,-127,-84,53,-64,101,-46,-127,41,91,-127,108,121,53,-62, 8,-57,-52,55,85,-35,-30,-57,-18,28,19,-34,8,34,10,24,-10,-14,34,60,-4,-89,43,55,-37,20,27,12,67,68,-14,7,-1,-67,-88,3,36,-44,49,-12,-38,31,57,-48,31,62,3,-73, 
  /* [0][1][][] */ 85,-94,-35,58,100,81,-127,-126,75,127,103,-93,-61,127,114,65,115,-112,15,124,-97,-94,84,127,-56,-66,118,127,82,69,-84,100,79,-70,-120,-127,102,-125,105,70,-122,45,67,-100,84,81,44,-14, 61,-127,-127,127,93,127,-99,-127,122,114,96,-127,-127,121,127,119,127,-127,6,110,-127,-95,127,123,-127,-127,127,107,88,43,-127,127,127,-127,-109,-112,127,-127,127,127,-117,127,127,-93,127,127,53,-127, 5,-70,-89,29,58,42,-88,-80,15,65,26,-58,-17,40,57,31,47,-13,42,72,19,-56,95,67,-54,10,37,41,69,8,-59,9,59,-78,-120,-62,61,-83,6,49,-18,36,88,-50,96,34,21,-66, 
  /* [0][2][][] */ -43,-51,-16,61,43,23,-49,53,-109,68,36,-90,-76,42,79,23,88,-47,-127,127,-114,-78,83,67,-88,-87,35,57,51,58,-52,61,41,-54,-57,-65,52,-44,84,57,-31,14,62,-60,3,-11,-107,6, -127,-42,-73,73,42,68,-27,-10,-83,55,4,-58,-120,46,68,55,88,-54,-121,93,-61,-110,91,42,-73,-27,58,56,37,57,-89,43,71,-66,-15,-20,65,-41,108,56,1,63,101,-21,36,17,-127,-76, -51,-40,-73,50,7,10,-17,27,-127,45,-2,-74,-51,33,33,32,34,-10,-75,108,-21,-26,31,88,-71,54,18,-2,72,54,-47,3,23,-56,-120,18,15,-29,51,47,2,17,57,13,3,58,-60,-80, 
};
const TfArray<4, int> tensor_dimension22 = { 4, { 1,3,3,48 } };
const TfArray<48, float> quant22_scale = { 48, { 0.0090709878131747246, 0.0041405479423701763, 0.0037752059288322926, 0.0038997649680823088, 0.0017437440110370517, 0.007793196476995945, 0.0043454938568174839, 0.0029324318747967482, 0.010617551393806934, 0.0020509129390120506, 0.0029691248200833797, 0.0037504637148231268, 0.0056848577223718166, 0.0069249956868588924, 0.0023581779096275568, 0.003349552396684885, 0.0019727149046957493, 0.0064288885332643986, 0.013036083430051804, 0.0024956951383501291, 0.0020249909721314907, 0.0042798295617103577, 0.0030988615471869707, 0.0034957290627062321, 0.0051477015949785709, 0.0037066491786390543, 0.010381327942013741, 0.0070263943634927273, 0.0031261942349374294, 0.010999026708304882, 0.0069984244182705879, 0.0046648052521049976, 0.0024334464687854052, 0.0046593630686402321, 0.0028460032772272825, 0.0035806696396321058, 0.0043218429200351238, 0.0031430230010300875, 0.0033135639969259501, 0.0022654354106634855, 0.0047243176959455013, 0.0097975712269544601, 0.0024212815333157778, 0.0048546893522143364, 0.0050360877066850662, 0.0062191514298319817, 0.011744906194508076, 0.003711299505084753, } };
const TfArray<48, int> quant22_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant22 = { (TfLiteFloatArray*)&quant22_scale, (TfLiteIntArray*)&quant22_zero, 3 };
const ALIGN(16) int32_t tensor_data23[48] = { -536, 25019, 25350, -926, 2928, -12744, 15910, 18228, -3296, 7086, -1387, 18675, 18055, -15682, -16639, -1103, 1582, 30026, -254, 925, 51535, 11493, -8101, -9584, 13061, 10911, -1944, -1790, -7738, -94, 28588, -1461, -554, 11154, 19468, 13139, -3949, 51444, -8345, 9730, 26861, 243, -4553, 14637, -77, -381, -2206, 8869, };
const TfArray<1, int> tensor_dimension23 = { 1, { 48 } };
const TfArray<48, float> quant23_scale = { 48, { 0.0002108297630911693, 9.6235467935912311e-05, 8.7744112533982843e-05, 9.0639136033132672e-05, 4.0528455429011956e-05, 0.00018113107944373041, 0.00010099886276293546, 6.8156186898704618e-05, 0.00024677530745975673, 4.766774145537056e-05, 6.9009009166620672e-05, 8.7169049947988242e-05, 0.00013212862540967762, 0.00016095217142719775, 5.4809253924759105e-05, 7.7850985690020025e-05, 4.5850243623135611e-05, 0.00014942155394237489, 0.00030298731871880591, 5.8005458413390443e-05, 4.7065255785128102e-05, 9.9472679721657187e-05, 7.2024377004709095e-05, 8.124845044221729e-05, 0.00011964394070673734, 8.6150699644349515e-05, 0.00024128495715558529, 0.00016330889775417745, 7.2659648139961064e-05, 0.00025564164388924837, 0.00016265882004518062, 0.0001084203613572754, 5.6558663345640525e-05, 0.00010829387611011043, 6.6147389588877559e-05, 8.3222657849546522e-05, 0.0001004491641651839, 7.3050789069384336e-05, 7.7014534326735884e-05, 5.2653715101769194e-05, 0.00010980356455547735, 0.00022771715885028243, 5.6275923270732164e-05, 0.00011283368803560734, 0.00011704978533089161, 0.00014454679330810905, 0.00027297751512378454, 8.625878399470821e-05, } };
const TfArray<48, int> quant23_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant23 = { (TfLiteFloatArray*)&quant23_scale, (TfLiteIntArray*)&quant23_zero, 0 };
const ALIGN(16) int8_t tensor_data24[8*1*1*48] = { 
  /* [0][0][][] */ -24,-43,49,-63,39,64,61,89,87,-31,-18,40,-38,-26,1,-23,34,31,17,-63,-34,15,-87,-43,19,-5,4,-68,-29,3,25,14,18,17,58,13,113,-31,-61,0,-57,-61,-39,-10,-71,-102,-127,60, 
  /* [1][0][][] */ -6,-8,-48,30,3,7,-41,-24,-77,31,23,95,-34,-3,-34,127,36,62,10,-48,-36,-7,-72,23,19,-2,-13,-90,48,-27,-82,-83,56,-42,-18,-68,30,41,63,-46,6,73,60,-43,0,-25,-70,-17, 
  /* [2][0][][] */ -2,-63,-34,-15,-35,13,8,18,96,11,2,-3,-50,-71,34,3,-3,-63,-11,-6,-89,42,-6,25,5,45,-28,-15,-29,-56,33,-57,-87,38,-54,58,-78,53,-20,-21,127,-15,-13,37,31,37,-67,-43, 
  /* [3][0][][] */ -31,-121,98,53,13,-95,-17,-5,-112,127,46,-61,38,14,-21,29,54,34,-47,56,71,60,27,-67,-5,59,51,25,-18,-60,6,19,-6,-12,39,9,-1,-87,-37,39,-23,-12,24,-80,-91,4,7,33, 
  /* [4][0][][] */ -12,53,-7,78,19,6,13,-10,-56,63,30,89,2,24,52,20,1,-100,0,-3,80,-2,-95,49,69,-19,27,26,48,36,-15,-50,-46,127,8,1,53,-26,29,18,-29,26,-6,-30,-7,-62,-36,15, 
  /* [5][0][][] */ -11,-9,-15,-46,-90,22,84,-2,3,45,-17,5,-69,-13,50,-30,-75,28,-49,-48,-4,127,5,25,104,43,-17,0,-27,-7,86,-48,-29,100,73,56,-24,45,72,17,-21,-25,-4,35,-57,35,13,29, 
  /* [6][0][][] */ -4,-36,-10,28,-44,-51,8,2,12,-6,46,8,-64,-26,32,50,0,-61,17,-49,63,-23,-8,-36,5,-7,4,26,42,-6,7,127,38,-32,-18,30,5,-13,5,19,0,38,-24,-65,-4,-41,-32,29, 
  /* [7][0][][] */ -20,-15,-38,2,3,-31,13,8,39,3,14,10,-5,14,4,-7,22,-6,10,-4,-61,16,7,-24,9,-8,-44,-17,-7,-11,25,24,14,-5,38,4,-29,127,-8,-28,-43,-8,-42,-32,13,67,-65,-14, 
};
const TfArray<4, int> tensor_dimension24 = { 4, { 8,1,1,48 } };
const TfArray<8, float> quant24_scale = { 8, { 0.0029477702919393778, 0.0044796098954975605, 0.0035238510463386774, 0.003558074589818716, 0.0041471235454082489, 0.0042630517855286598, 0.0063760988414287567, 0.0084646018221974373, } };
const TfArray<8, int> quant24_zero = { 8, { 0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant24 = { (TfLiteFloatArray*)&quant24_scale, (TfLiteIntArray*)&quant24_zero, 0 };
const ALIGN(16) int32_t tensor_data25[8] = { 8285, -179, 15756, -5128, -11372, -11322, -4452, -3147, };
const TfArray<1, int> tensor_dimension25 = { 1, { 8 } };
const TfArray<8, float> quant25_scale = { 8, { 6.9359302869997919e-05, 0.00010540258517721668, 8.2914142694789916e-05, 8.3719402027782053e-05, 9.7579380962997675e-05, 0.00010030710109276697, 0.00015002585132606328, 0.00019916710152756423, } };
const TfArray<8, int> quant25_zero = { 8, { 0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant25 = { (TfLiteFloatArray*)&quant25_scale, (TfLiteIntArray*)&quant25_zero, 0 };
const ALIGN(16) int8_t tensor_data26[48*1*1*8] = { 
  /* [0][0][][] */ -70,-127,-50,69,-51,-34,86,-85, 
  /* [1][0][][] */ -15,127,59,-59,-11,-79,-60,95, 
  /* [2][0][][] */ -127,-62,60,12,74,12,33,-33, 
  /* [3][0][][] */ -18,-45,-127,-85,32,-45,-50,78, 
  /* [4][0][][] */ -30,-79,127,-31,87,-2,44,18, 
  /* [5][0][][] */ -23,88,81,-112,127,21,-48,107, 
  /* [6][0][][] */ -127,103,56,66,-65,7,62,-115, 
  /* [7][0][][] */ 55,-16,32,12,47,-105,-24,127, 
  /* [8][0][][] */ 5,72,-12,-32,22,96,127,-60, 
  /* [9][0][][] */ 61,110,5,-73,-110,-42,-76,127, 
  /* [10][0][][] */ 38,-16,48,-19,14,70,-127,-73, 
  /* [11][0][][] */ -50,1,-98,-65,127,7,10,28, 
  /* [12][0][][] */ 124,78,-33,16,127,116,9,-12, 
  /* [13][0][][] */ -127,-111,6,48,-88,22,48,-4, 
  /* [14][0][][] */ -16,97,-36,104,-45,127,14,46, 
  /* [15][0][][] */ 1,-42,-51,-40,127,45,2,71, 
  /* [16][0][][] */ 92,-116,-37,67,74,-72,43,-127, 
  /* [17][0][][] */ -72,-47,-127,96,32,89,74,-125, 
  /* [18][0][][] */ 74,-11,74,21,-51,-127,-27,-9, 
  /* [19][0][][] */ -12,127,23,39,75,-94,-60,-62, 
  /* [20][0][][] */ -55,-21,-127,-23,11,-29,-3,-14, 
  /* [21][0][][] */ -100,-41,88,29,-105,-76,127,-39, 
  /* [22][0][][] */ 71,-19,-127,-78,-73,-31,-2,26, 
  /* [23][0][][] */ 2,60,125,10,-104,8,17,-127, 
  /* [24][0][][] */ -101,30,56,65,127,107,-31,-4, 
  /* [25][0][][] */ -51,-127,-58,14,-43,39,36,25, 
  /* [26][0][][] */ 68,66,-125,-52,-127,7,-82,56, 
  /* [27][0][][] */ 55,68,-63,47,-127,5,-38,-18, 
  /* [28][0][][] */ -4,98,34,-56,78,108,-81,-127, 
  /* [29][0][][] */ 51,21,-6,-48,-127,12,41,-38, 
  /* [30][0][][] */ -82,4,27,127,38,30,-35,-24, 
  /* [31][0][][] */ 15,-124,8,-87,-127,67,-42,-63, 
  /* [32][0][][] */ -127,-23,14,-10,23,-47,-5,30, 
  /* [33][0][][] */ 46,-95,-115,-127,23,47,-69,12, 
  /* [34][0][][] */ 8,72,127,-30,-74,-20,30,-47, 
  /* [35][0][][] */ 79,19,7,1,-127,-53,-122,-35, 
  /* [36][0][][] */ 127,38,68,-16,13,-49,86,40, 
  /* [37][0][][] */ 127,124,5,-4,37,94,-119,31, 
  /* [38][0][][] */ -40,27,127,113,-65,48,25,-107, 
  /* [39][0][][] */ 16,16,105,-70,127,-40,-71,7, 
  /* [40][0][][] */ 78,13,36,-1,-91,-127,87,15, 
  /* [41][0][][] */ 25,-77,18,127,-19,91,4,114, 
  /* [42][0][][] */ -15,-113,92,-61,127,3,85,43, 
  /* [43][0][][] */ -6,0,-103,-7,110,30,-92,127, 
  /* [44][0][][] */ 69,-4,127,-17,16,46,-62,31, 
  /* [45][0][][] */ -78,-24,8,-69,-75,-127,-56,118, 
  /* [46][0][][] */ -67,93,77,42,-31,-44,61,-127, 
  /* [47][0][][] */ -43,-26,48,104,-50,-124,127,97, 
};
const TfArray<4, int> tensor_dimension26 = { 4, { 48,1,1,8 } };
const TfArray<48, float> quant26_scale = { 48, { 0.0024846636224538088, 0.0035475678741931915, 0.0023324741050601006, 0.0024885437451303005, 0.0033821591641753912, 0.0016740389401093125, 0.0034722043201327324, 0.0018265710677951574, 0.001365303760394454, 0.0034073854330927134, 0.0026429020799696445, 0.0033222439233213663, 0.0023748287931084633, 0.003333493135869503, 0.0029586113523691893, 0.0036368765868246555, 0.0027731203008443117, 0.0032413857989013195, 0.0025486317463219166, 0.0039409752935171127, 0.004878179170191288, 0.0018019211711362004, 0.0030660934280604124, 0.0024705093819648027, 0.0017656177515164018, 0.0022266537416726351, 0.0043636402115225792, 0.0016664338763803244, 0.0021170573309063911, 0.0040029855445027351, 0.010164028033614159, 0.0019982133526355028, 0.0052158567123115063, 0.002308194525539875, 0.0028840145096182823, 0.0039705326780676842, 0.00087597325909882784, 0.0015788215678185225, 0.0029205712489783764, 0.0011148997582495213, 0.0031228282023221254, 0.0041693965904414654, 0.0024922871962189674, 0.0028801027219742537, 0.0027309837751090527, 0.0031140041537582874, 0.0035867905244231224, 0.0019276130478829145, } };
const TfArray<48, int> quant26_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant26 = { (TfLiteFloatArray*)&quant26_scale, (TfLiteIntArray*)&quant26_zero, 0 };
const ALIGN(16) int32_t tensor_data27[48] = { 3226, 5146, -7775, 5822, 3337, 8929, 2756, 12521, 16142, 4409, -2942, -1813, 2985, 3803, 4711, -1206, -246, 4301, 7044, -989, 1416, 10434, 4853, 6220, 9673, 9041, 715, 12635, 2116, 4209, -974, 9447, 1437, 6455, 6059, 3787, 36851, 12401, 4349, 18104, 1241, 473, 6575, 2547, 5018, 572, 1993, 4980, };
const TfArray<1, int> tensor_dimension27 = { 1, { 48 } };
const TfArray<48, float> quant27_scale = { 48, { 0.00011156374966958538, 0.00015928914945106953, 0.00010473029396962374, 0.000111737972474657, 0.00015186214295681566, 7.5165931775700301e-05, 0.00015590526163578033, 8.2014768850058317e-05, 6.1303428083192557e-05, 0.00015299483493436128, 0.00011866880231536925, 0.00014917190128471702, 0.00010663206194294617, 0.00014967699826229364, 0.00013284444867167622, 0.00016329920617863536, 0.00012451573275029659, 0.00014554128574673086, 0.00011443597759352997, 0.00017695351561997086, 0.00021903486049268395, 8.0907964729703963e-05, 0.00013767048949375749, 0.00011092820932390168, 7.9277910117525607e-05, 9.9978860816918314e-05, 0.00019593157048802823, 7.4824456532951444e-05, 9.5057876023929566e-05, 0.00017973783542402089, 0.00045637448783963919, 8.9721666881814599e-05, 0.00023419690842274576, 0.0001036401154124178, 0.00012949497613590211, 0.00017828067939262837, 3.9332029700744897e-05, 7.089057908160612e-05, 0.00013113641762174666, 5.0060054491041228e-05, 0.00014021794777363539, 0.0001872098509920761, 0.00011190605437150225, 0.00012931933451909572, 0.00012262375093996525, 0.00013982172822579741, 0.00016105029499158263, 8.6551648564636707e-05, } };
const TfArray<48, int> quant27_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant27 = { (TfLiteFloatArray*)&quant27_scale, (TfLiteIntArray*)&quant27_zero, 0 };
const ALIGN(16) int8_t tensor_data28[1*3*3*48] = { 
  /* [0][0][][] */ -38,-5,45,-9,127,-42,43,17,35,25,-28,-31,33,45,-88,48,76,-31,-24,-7,-68,-39,-66,6,11,29,43,-75,-44,127,30,-68,-36,100,98,-19,8,-96,-122,-23,14,-21,72,-85,-2,-46,-55,36, -57,127,-22,8,12,-22,115,-34,93,12,-36,127,57,127,-44,28,127,-37,-15,60,-102,-49,83,-86,24,64,-95,-2,-33,-119,119,-110,-127,-70,40,1,-53,-68,-127,10,-63,0,83,-127,26,-50,54,35, -36,-6,-17,6,95,-48,28,-32,76,17,-54,-33,3,-15,-66,53,46,-66,-11,-30,-71,12,-65,-12,52,20,13,-127,-45,47,-76,-85,-62,-14,100,7,6,-64,-87,6,27,0,-11,-36,-18,-55,-62,17, 
  /* [0][1][][] */ -127,81,-33,-49,-10,-69,35,13,-1,21,46,36,118,111,-100,7,99,-80,35,44,-40,-105,-127,-1,-127,-11,-21,12,-23,0,25,-38,-9,127,-75,-127,32,-76,37,54,-67,38,-111,43,-6,-127,-23,-32, 0,98,127,127,-54,101,-127,127,127,-127,-72,56,127,49,127,-127,-70,-39,127,28,-127,127,91,35,99,81,74,126,127,-84,127,29,-17,-110,-27,-59,127,118,86,61,-39,127,-65,66,127,29,-12,-127, -96,44,-65,-28,-43,-57,15,-42,-18,-2,54,18,73,86,-40,72,43,-127,1,32,31,-101,-114,-11,13,-39,-14,15,-7,18,49,-27,14,-70,-67,-77,18,-127,30,-127,-44,25,127,70,-23,-49,-30,98, 
  /* [0][2][][] */ 7,-17,-19,5,30,-102,49,27,70,36,95,39,-31,15,-108,64,21,-29,-44,27,-45,19,-92,69,-9,-16,-27,-31,-11,75,27,41,-17,20,-51,3,-38,-84,89,-29,100,-2,12,-6,-32,-8,-10,-44, -32,99,-18,25,-125,-127,111,-108,95,22,-13,-3,-52,63,-63,91,43,40,-20,127,-76,37,57,127,9,-127,127,-3,-11,-34,-1,-29,-28,-66,-127,-58,-64,-96,46,31,127,51,-81,0,-31,-41,-127,-39, 12,-41,-12,7,27,-20,14,2,93,18,127,16,51,9,-71,30,-3,-12,-63,43,-54,27,-79,49,-12,-34,-2,-64,-21,6,-18,127,-16,-16,-32,5,-32,-74,55,-2,64,0,55,11,-26,15,-27,55, 
};
const TfArray<4, int> tensor_dimension28 = { 4, { 1,3,3,48 } };
const TfArray<48, float> quant28_scale = { 48, { 0.0052951634861528873, 0.0051634185947477818, 0.044265124946832657, 0.0089118629693984985, 0.0078167794272303581, 0.0057299775071442127, 0.0049789007753133774, 0.013901107013225555, 0.0041773528791964054, 0.011204726994037628, 0.010568656027317047, 0.0087665515020489693, 0.0062153548933565617, 0.0035441035870462656, 0.0037557224277406931, 0.0085303261876106262, 0.0048704100772738457, 0.0039439806714653969, 0.016479212790727615, 0.0064016301184892654, 0.0028751508798450232, 0.011566819623112679, 0.0065516182221472263, 0.0066018598154187202, 0.012456663884222507, 0.010592450387775898, 0.010236076079308987, 0.0088098794221878052, 0.015334809198975563, 0.0068881437182426453, 0.0043117818422615528, 0.0061134835705161095, 0.0046593560837209225, 0.0064524328336119652, 0.0073106014169752598, 0.0071698590181767941, 0.038838330656290054, 0.0041659167036414146, 0.0076876673847436905, 0.019397277384996414, 0.0086813215166330338, 0.0063350927084684372, 0.0086229005828499794, 0.0066291522234678268, 0.012452946044504642, 0.0040810350328683853, 0.0065943715162575245, 0.0091374535113573074, } };
const TfArray<48, int> quant28_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant28 = { (TfLiteFloatArray*)&quant28_scale, (TfLiteIntArray*)&quant28_zero, 3 };
const ALIGN(16) int32_t tensor_data29[48] = { 14590, -15971, -1203, 2515, -3026, 9214, 3651, 374, -19537, 5389, -1423, -1643, -10564, -14291, 9851, 355, -7542, 22685, -2076, -5415, 25676, 1329, 6629, -7680, -2521, 1433, -5272, 3776, 3061, -99, 1299, 10316, 17646, 318, 4853, 13408, -551, 33122, 371, 720, -5105, -9723, -4590, 6392, 1985, 20023, 14117, -5397, };
const TfArray<1, int> tensor_dimension29 = { 1, { 48 } };
const TfArray<48, float> quant29_scale = { 48, { 9.5152674475684762e-05, 9.2785252491012216e-05, 0.00079543248284608126, 0.00016014379798434675, 0.00014046544674783945, 0.00010296616528648883, 8.9469518570695072e-05, 0.00024979919544421136, 7.5065916462335736e-05, 0.0002013459597947076, 0.0001899159251479432, 0.00015753258776385337, 0.00011168827040819451, 6.3686595240142196e-05, 6.7489330831449479e-05, 0.00015328767767641693, 8.7519969383720309e-05, 7.0872280048206449e-05, 0.00029612705111503601, 0.00011503558198455721, 5.1665694627445191e-05, 0.00020785265951417387, 0.00011773082951549441, 0.00011863365944009274, 0.00022384292969945818, 0.0001903435040730983, 0.00018393955542705953, 0.00015831118798814714, 0.00027556243003346026, 0.00012377811071928591, 7.7481570770032704e-05, 0.00010985766857629642, 8.3727383753284812e-05, 0.00011594849638640881, 0.00013136955385562032, 0.00012884046009276062, 0.00069791445275768638, 7.4860414315480739e-05, 0.00013814533303957433, 0.00034856388811022043, 0.00015600102778989822, 0.00011383992386981845, 0.00015495122352149338, 0.00011912409536307678, 0.00022377612185664475, 7.3335111665073782e-05, 0.00011849909787997603, 0.00016419759776908904, } };
const TfArray<48, int> quant29_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant29 = { (TfLiteFloatArray*)&quant29_scale, (TfLiteIntArray*)&quant29_zero, 0 };
const ALIGN(16) int8_t tensor_data30[8*1*1*48] = { 
  /* [0][0][][] */ 64,64,-87,57,12,27,-121,-45,7,-39,16,-39,-40,-4,52,8,55,-10,75,-21,35,-51,51,-28,11,-27,-41,-2,-33,-19,-25,3,68,6,14,20,127,53,10,-17,32,-34,-10,-27,102,59,18,-66, 
  /* [1][0][][] */ 80,34,17,-8,10,46,-21,-27,19,62,-25,-56,113,-50,9,44,0,29,12,-98,127,-27,40,19,55,-15,14,5,-5,-54,65,67,65,94,8,120,32,17,-10,26,55,14,32,41,27,66,110,-59, 
  /* [2][0][][] */ -13,-8,74,112,-53,-9,7,58,44,65,12,-80,-29,72,33,55,-79,-121,46,-36,-3,28,-39,-105,3,-60,-6,-2,-127,37,3,-12,-58,3,-82,-37,-12,18,-126,-41,-33,-62,-46,31,65,-61,-49,32, 
  /* [3][0][][] */ -14,36,-79,-12,43,-91,2,67,92,-87,-64,8,-22,-43,-1,55,31,5,-53,-16,13,44,-89,43,-9,-37,41,6,81,-26,24,-47,52,-9,-76,-60,-127,-21,-74,14,-58,-44,43,-23,-56,19,-22,-32, 
  /* [4][0][][] */ 37,-32,34,-8,-59,97,24,52,-105,-51,45,54,61,-46,-46,-69,127,64,55,-19,-25,-83,-10,40,-51,0,-23,-100,-35,-37,79,59,75,5,94,92,79,72,64,20,-25,34,-38,-24,50,57,85,-69, 
  /* [5][0][][] */ 24,73,8,72,18,30,-28,-76,-100,16,-19,-12,21,63,29,-83,63,103,-29,38,-29,-31,-20,-36,-107,-77,-21,67,2,32,-6,42,-4,-53,53,6,-16,127,-33,-91,-57,-19,-18,-5,-13,-10,-23,81, 
  /* [6][0][][] */ 105,42,-13,95,-110,21,35,66,3,-75,55,52,89,-52,-35,-55,44,29,-64,15,61,1,-31,34,25,46,-49,-43,-21,-13,72,68,16,-25,4,86,91,-55,-6,11,-127,88,-89,82,45,85,104,-42, 
  /* [7][0][][] */ 45,-2,127,38,-36,64,-103,18,-48,119,-15,-38,88,65,-10,-5,-75,-9,-81,-5,-7,53,-25,-4,-4,56,71,-29,20,6,23,-6,-107,-6,59,37,112,-24,50,3,-4,-26,-46,-58,8,-32,31,32, 
};
const TfArray<4, int> tensor_dimension30 = { 4, { 8,1,1,48 } };
const TfArray<8, float> quant30_scale = { 8, { 0.0063483663834631443, 0.0022820464801043272, 0.0038357495795935392, 0.0030878942925482988, 0.0036002967972308397, 0.003766271285712719, 0.0024501995649188757, 0.0036837300285696983, } };
const TfArray<8, int> quant30_zero = { 8, { 0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant30 = { (TfLiteFloatArray*)&quant30_scale, (TfLiteIntArray*)&quant30_zero, 0 };
const ALIGN(16) int32_t tensor_data31[8] = { -11352, -32672, 10312, 9162, -16454, -72, -23972, -2447, };
const TfArray<1, int> tensor_dimension31 = { 1, { 8 } };
const TfArray<8, float> quant31_scale = { 8, { 0.00014937332889530808, 5.3695213864557445e-05, 9.025293547892943e-05, 7.265633757924661e-05, 8.4712868556380272e-05, 8.8618151494301856e-05, 5.7651755923870951e-05, 8.6676001956220716e-05, } };
const TfArray<8, int> quant31_zero = { 8, { 0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant31 = { (TfLiteFloatArray*)&quant31_scale, (TfLiteIntArray*)&quant31_zero, 0 };
const ALIGN(16) int8_t tensor_data32[48*1*1*8] = { 
  /* [0][0][][] */ -127,42,-30,-18,94,71,67,-34, 
  /* [1][0][][] */ 13,-43,-61,-7,-66,-127,50,33, 
  /* [2][0][][] */ -81,49,-5,-51,-61,26,-55,127, 
  /* [3][0][][] */ 59,51,60,-4,-46,-127,50,-43, 
  /* [4][0][][] */ -28,79,-119,55,-127,97,-5,31, 
  /* [5][0][][] */ -47,35,58,-41,-110,-127,-75,-24, 
  /* [6][0][][] */ -62,127,125,-16,-58,-53,-13,-85, 
  /* [7][0][][] */ 7,-7,26,56,-2,-127,-20,56, 
  /* [8][0][][] */ 127,18,-63,83,-85,-86,-85,-26, 
  /* [9][0][][] */ 127,-42,-68,-95,-30,-46,-55,123, 
  /* [10][0][][] */ -127,3,2,119,30,109,18,-104, 
  /* [11][0][][] */ 52,17,57,-8,26,126,127,72, 
  /* [12][0][][] */ -27,-77,-35,-65,127,-8,20,51, 
  /* [13][0][][] */ 7,44,-31,109,66,-127,53,57, 
  /* [14][0][][] */ 66,54,118,21,67,-127,-90,-7, 
  /* [15][0][][] */ -103,63,108,116,8,34,14,-127, 
  /* [16][0][][] */ -96,-78,38,-81,127,69,-50,33, 
  /* [17][0][][] */ 49,-67,-61,4,-22,127,-41,54, 
  /* [18][0][][] */ 26,127,-2,-48,-39,37,106,-58, 
  /* [19][0][][] */ -14,99,127,119,-34,37,1,51, 
  /* [20][0][][] */ -5,-37,119,-127,-62,-14,57,-54, 
  /* [21][0][][] */ -79,71,55,-109,127,86,108,-6, 
  /* [22][0][][] */ 80,-31,-108,69,29,-48,-19,127, 
  /* [23][0][][] */ 41,-86,-127,-36,59,-11,-76,82, 
  /* [24][0][][] */ 48,2,-80,11,-40,56,-127,123, 
  /* [25][0][][] */ -11,-5,61,3,127,-3,-70,-33, 
  /* [26][0][][] */ -23,91,97,-24,-49,-44,21,-127, 
  /* [27][0][][] */ -8,39,78,-68,-2,-16,42,-127, 
  /* [28][0][][] */ 127,31,87,118,79,8,59,125, 
  /* [29][0][][] */ 63,71,93,-1,-34,58,-97,127, 
  /* [30][0][][] */ 29,-4,-89,61,-127,-67,-18,35, 
  /* [31][0][][] */ -5,78,127,-37,-48,25,70,-107, 
  /* [32][0][][] */ 65,-51,-27,23,127,101,51,-40, 
  /* [33][0][][] */ 33,-8,-127,28,15,-31,-58,60, 
  /* [34][0][][] */ 52,-54,44,-127,-8,73,-10,27, 
  /* [35][0][][] */ -13,32,46,12,-4,-127,14,-22, 
  /* [36][0][][] */ -13,-8,-33,-127,-30,5,-15,-44, 
  /* [37][0][][] */ 68,-6,-29,-80,-48,127,-53,-53, 
  /* [38][0][][] */ 87,-49,-5,109,60,33,-30,127, 
  /* [39][0][][] */ 127,101,23,60,-23,103,-89,-4, 
  /* [40][0][][] */ 25,-77,-127,-4,26,-11,-13,99, 
  /* [41][0][][] */ 30,-51,-127,-55,14,-63,-25,-29, 
  /* [42][0][][] */ 57,127,69,122,-36,-1,28,23, 
  /* [43][0][][] */ 83,-58,-127,-88,-98,-73,52,39, 
  /* [44][0][][] */ -11,127,99,-86,-83,16,109,-117, 
  /* [45][0][][] */ 44,29,-127,95,-59,12,37,48, 
  /* [46][0][][] */ 36,-19,-83,-127,64,-31,-38,51, 
  /* [47][0][][] */ 81,-115,127,-47,76,-25,1,-2, 
};
const TfArray<4, int> tensor_dimension32 = { 4, { 48,1,1,8 } };
const TfArray<48, float> quant32_scale = { 48, { 0.00068496324820443988, 0.0015338697703555226, 0.0035261195152997971, 0.0027152439579367638, 0.0025377499405294657, 0.0020192409865558147, 0.0016339748399332166, 0.0039694672450423241, 0.002072314964607358, 0.001786399632692337, 0.00078022910747677088, 0.0023348575923591852, 0.0022954095620661974, 0.0020485843997448683, 0.0041095605120062828, 0.0021814275532960892, 0.0015343007398769259, 0.0031367957126349211, 0.0016161769162863493, 0.0030187463853508234, 0.0024641135241836309, 0.0021887600887566805, 0.0019574277102947235, 0.0013805605703964829, 0.0026269340887665749, 0.0032624255400151014, 0.0021835695952177048, 0.0016386883798986673, 0.0022363141179084778, 0.0016911131097003818, 0.0028048017993569374, 0.0015927638160064816, 0.0037261880934238434, 0.0018704877002164721, 0.0026707414072006941, 0.0031390688382089138, 0.0035394274163991213, 0.0035024422686547041, 0.0026720864698290825, 0.0038602596614509821, 0.0012744750129058957, 0.0034451624378561974, 0.0010294567327946424, 0.0022568546701222658, 0.0026993732899427414, 0.0015766439028084278, 0.0024016625247895718, 0.0032981443218886852, } };
const TfArray<48, int> quant32_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant32 = { (TfLiteFloatArray*)&quant32_scale, (TfLiteIntArray*)&quant32_zero, 0 };
const ALIGN(16) int32_t tensor_data33[48] = { 31864, 12401, 1231, 3319, 6374, 6601, 9606, 3449, 6060, -7437, 31064, 2025, 6590, 5867, 3359, 1723, 10408, -1459, 11864, 227, 6168, -833, 6625, 13279, 3053, -4238, 4898, 10652, 1728, 9067, 1618, 11256, 466, 10167, 144, -3944, 3581, 2006, 1079, 1106, 15325, -1160, 19915, 4721, 1021, 11281, 4905, -2041, };
const TfArray<1, int> tensor_dimension33 = { 1, { 48 } };
const TfArray<48, float> quant33_scale = { 48, { 3.2360923796659335e-05, 7.2467308200430125e-05, 0.00016659066022839397, 0.00012828104081563652, 0.00011989538324996829, 9.5398550911340863e-05, 7.7196746133267879e-05, 0.00018753651238512248, 9.7906020528171211e-05, 8.4398016042541713e-05, 3.6861736589344218e-05, 0.00011030978203052655, 0.00010844606731552631, 9.6784875495359302e-05, 0.00019415518909227103, 0.00010306101466994733, 7.248766632983461e-05, 0.0001481971557950601, 7.6355885539669544e-05, 0.00014261994510889053, 0.0001164164423244074, 0.00010340743756387383, 9.2478199803736061e-05, 6.5224252466578037e-05, 0.00012410886120051146, 0.000154132503666915, 0.000103162215964403, 7.7419434092007577e-05, 0.000105654115031939, 7.9896228271536529e-05, 0.00013251218479126692, 7.524974353145808e-05, 0.00017604285676497966, 8.8370739831589162e-05, 0.00012617853644769639, 0.00014830454892944545, 0.00016721939027775079, 0.00016547203995287418, 0.00012624207010958344, 0.00018237702897749841, 6.021226363372989e-05, 0.00016276586393360049, 4.8636433348292485e-05, 0.00010662455315468833, 0.00012753123883157969, 7.4488161772023886e-05, 0.00011346596147632226, 0.00015582003106828779, } };
const TfArray<48, int> quant33_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant33 = { (TfLiteFloatArray*)&quant33_scale, (TfLiteIntArray*)&quant33_zero, 0 };
const ALIGN(16) int8_t tensor_data34[1*3*3*48] = { 
  /* [0][0][][] */ 80,92,-20,32,-15,12,-18,-2,27,-31,22,-11,37,-85,15,41,127,34,-92,16,91,90,-39,-26,80,34,30,-9,-48,6,11,-34,79,13,69,9,-36,64,54,57,-77,86,-83,-87,51,-66,-62,-6, 127,127,-67,50,48,58,-56,-127,58,24,127,-28,-5,-65,17,15,-15,127,-93,72,67,127,61,-22,14,30,22,127,-127,62,-13,-127,81,-38,-19,71,-49,107,-6,18,-127,-84,74,-1,12,14,-127,38, 43,68,-2,48,1,-25,-19,16,37,-49,28,-29,-12,-92,8,2,115,-51,-63,8,83,88,-47,48,75,65,23,17,-34,-11,6,-25,69,35,48,19,-7,42,99,-24,-50,74,29,59,37,72,15,-25, 
  /* [0][1][][] */ 1,-25,-127,96,5,77,82,-32,28,74,-64,76,127,-36,-37,-81,-26,96,83,-35,-94,27,1,-106,57,27,11,20,58,75,48,67,28,127,10,38,-54,39,-37,127,49,18,75,-127,28,-79,-32,51, 68,-86,-55,-127,127,22,127,-81,-127,127,-7,-50,-115,127,127,-27,-109,95,11,127,33,-9,127,-13,-127,127,21,-74,-94,23,-127,103,127,-116,-13,127,127,66,-83,73,70,-52,-20,6,127,-59,5,15, -34,-18,-87,56,-36,127,59,2,29,39,-54,20,-25,-28,-27,-22,-45,91,119,-46,-127,13,-83,127,21,31,21,29,46,66,71,44,-36,13,-64,-73,-42,-16,15,21,11,76,-36,108,2,52,-43,38, 
  /* [0][2][][] */ -18,-8,21,39,-24,34,18,13,23,-42,-14,96,31,-90,-52,31,87,-31,24,6,-26,14,-57,-2,44,14,-16,-1,96,34,28,17,-35,1,121,-7,-17,95,95,37,43,99,92,-22,-38,-127,-45,-8, -101,17,-41,54,-125,6,-32,-33,37,59,-98,127,-26,-41,-38,127,-50,19,-127,-16,-36,-15,-24,-47,-2,68,-127,-26,-65,127,85,30,32,-52,65,23,-14,127,-61,17,-24,-127,-127,-22,-102,9,-94,127, -40,-2,14,23,-18,21,10,19,23,-70,-31,83,-10,-110,-40,14,91,-92,87,32,-85,-46,-10,32,23,22,-5,-9,58,38,34,9,-9,8,127,36,-4,64,127,-2,32,60,-76,34,-17,38,-34,-20, 
};
const TfArray<4, int> tensor_dimension34 = { 4, { 1,3,3,48 } };
const TfArray<48, float> quant34_scale = { 48, { 0.012466724961996078, 0.0072921854443848133, 0.0043260254897177219, 0.0061052152886986732, 0.010741180740296841, 0.004991868045181036, 0.0089138858020305634, 0.0076794512569904327, 0.0077376579865813255, 0.015858449041843414, 0.01388959027826786, 0.0031433149706572294, 0.0098237087950110435, 0.0038822623901069164, 0.0076054506935179234, 0.011563347652554512, 0.007303187157958746, 0.0048026866279542446, 0.0081020742654800415, 0.0086654545739293098, 0.005876671988517046, 0.0050067217089235783, 0.0099663464352488518, 0.010191606357693672, 0.01024340745061636, 0.0094155482947826385, 0.012380673550069332, 0.018566861748695374, 0.0055250590667128563, 0.0047955908812582493, 0.0097129810601472855, 0.0092017799615859985, 0.0051681622862815857, 0.017601678147912025, 0.0031044862698763609, 0.014113939367234707, 0.010050392709672451, 0.0012979920720681548, 0.005913065280765295, 0.004456713330000639, 0.012340739369392395, 0.0071113873273134232, 0.012202849611639977, 0.0071259411051869392, 0.007019218523055315, 0.0056917616166174412, 0.0048410207964479923, 0.012098251841962337, } };
const TfArray<48, int> quant34_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant34 = { (TfLiteFloatArray*)&quant34_scale, (TfLiteIntArray*)&quant34_zero, 3 };
const ALIGN(16) int32_t tensor_data35[48] = { -8445, -7630, 10043, -58, 503, -13490, -9232, 14833, 7844, -5052, 1935, -1598, -2821, 27899, 10488, -1527, -898, -6233, 7224, -5265, 13975, -7957, 3812, -990, 1394, -8664, 240, -4494, 5177, -28112, -8248, -1903, -5906, -290, 902, -1603, 7545, 545, 2128, -13002, 1383, 4076, -957, -849, 3, 2435, 14159, -2925, };
const TfArray<1, int> tensor_dimension35 = { 1, { 48 } };
const TfArray<48, float> quant35_scale = { 48, { 0.00019099470227956772, 0.00011171889491379261, 6.6276261350139976e-05, 9.353408677270636e-05, 0.00016455874720122665, 7.6477212132886052e-05, 0.00013656393275596201, 0.00011765195085899904, 0.00011854369950015098, 0.00024295713228639215, 0.00021279350039549172, 4.8156714910874143e-05, 0.00015050274669192731, 5.9477653849171475e-05, 0.00011651823297142982, 0.00017715463764034212, 0.00011188744974788278, 7.3578885348979384e-05, 0.0001241266872966662, 0.00013275787932798266, 9.0032721345778555e-05, 7.6704774983227253e-05, 0.00015268800780177116, 0.0001561390672577545, 0.00015693267050664872, 0.00014424958499148488, 0.0001896763569675386, 0.00028445097268559039, 8.4645886090584099e-05, 7.3470175266265869e-05, 0.00014880635717418045, 0.00014097457460593432, 7.9178098530974239e-05, 0.00026966401492245495, 4.7561843530274928e-05, 0.00021623061911668628, 0.00015397561946883798, 1.9885705114575103e-05, 9.0590285253711045e-05, 6.8278444814495742e-05, 0.00018906455079559237, 0.00010894900333369151, 0.00018695203470997512, 0.00010917197505477816, 0.0001075369436875917, 8.7199827248696238e-05, 7.4166178819723427e-05, 0.00018534956325311214, } };
const TfArray<48, int> quant35_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant35 = { (TfLiteFloatArray*)&quant35_scale, (TfLiteIntArray*)&quant35_zero, 0 };
const ALIGN(16) int8_t tensor_data36[8*1*1*48] = { 
  /* [0][0][][] */ 127,-39,15,-42,20,47,16,57,96,-84,47,3,-49,74,12,-64,6,-14,-49,-18,-12,-42,20,-47,-72,-29,-51,-44,-32,88,-41,38,38,-53,29,-41,56,-54,-67,-2,23,-30,-66,1,47,-22,68,-24, 
  /* [1][0][][] */ 33,-6,-13,52,51,58,12,42,65,-106,-22,1,35,37,-42,-34,-42,-65,-90,0,2,-56,64,81,0,-67,-16,42,-36,70,-86,127,-9,46,-10,-39,-78,-10,-8,-22,-66,-16,-30,51,11,6,11,-107, 
  /* [2][0][][] */ -38,-8,-68,35,-63,-25,-16,23,-102,-70,-74,-23,-13,43,-101,12,83,-78,48,-14,127,54,-32,24,53,82,29,-81,-35,-17,62,-7,-43,47,67,-47,54,-3,84,96,-40,88,32,-9,-70,46,-55,56, 
  /* [3][0][][] */ 13,-34,12,48,-18,23,6,57,82,117,-127,-55,20,-29,-61,67,-55,-17,-24,50,-48,-8,92,-8,-25,15,-53,61,-36,36,-84,-20,28,3,20,29,69,-15,21,-14,-43,95,80,15,36,-18,3,-45, 
  /* [4][0][][] */ -35,-55,26,-36,4,92,-30,-59,27,-59,61,38,-53,-33,-17,11,73,7,-16,38,-70,-22,82,-16,-100,-16,-3,-1,31,-31,7,72,-47,42,-19,57,-30,39,-13,17,-45,34,-40,30,127,46,-31,4, 
  /* [5][0][][] */ -66,-44,51,-127,-23,16,-39,-74,-6,57,-50,68,-69,27,66,32,70,36,72,8,49,-10,-23,-42,60,-77,5,-39,-13,-40,46,-74,-24,-30,54,15,-18,21,48,65,90,23,15,-20,-5,0,-38,25, 
  /* [6][0][][] */ -55,-79,31,18,-71,-72,-19,-103,-121,14,-127,61,30,-30,81,49,-39,10,28,122,3,-12,64,96,-59,-36,68,53,15,-38,-19,-82,-58,96,72,-80,-63,74,88,-13,-63,100,71,-46,4,-37,-51,8, 
  /* [7][0][][] */ 20,-13,7,-26,-6,16,-59,-47,-127,-39,93,37,12,-14,55,4,5,31,-3,-16,-23,21,-20,-16,57,-2,-30,35,-18,-23,-2,-67,-101,-34,-27,7,39,-30,-7,16,56,18,40,-9,27,-31,20,20, 
};
const TfArray<4, int> tensor_dimension36 = { 4, { 8,1,1,48 } };
const TfArray<8, float> quant36_scale = { 8, { 0.0072370306588709354, 0.0062133059836924076, 0.0043938122689723969, 0.0043397513218224049, 0.0040543428622186184, 0.0050303624011576176, 0.0048708105459809303, 0.0070547573268413544, } };
const TfArray<8, int> quant36_zero = { 8, { 0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant36 = { (TfLiteFloatArray*)&quant36_scale, (TfLiteIntArray*)&quant36_zero, 0 };
const ALIGN(16) int32_t tensor_data37[8] = { -6047, 700, -3097, -8126, 1983, -6519, 8901, 9181, };
const TfArray<1, int> tensor_dimension37 = { 1, { 8 } };
const TfArray<8, float> quant37_scale = { 8, { 0.00014573069347534329, 0.00012511614477261901, 8.8477347162552178e-05, 8.7388732936233282e-05, 8.1641519500408322e-05, 0.00010129543807124719, 9.8082571639679372e-05, 0.00014206029300112277, } };
const TfArray<8, int> quant37_zero = { 8, { 0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant37 = { (TfLiteFloatArray*)&quant37_scale, (TfLiteIntArray*)&quant37_zero, 0 };
const ALIGN(16) int8_t tensor_data38[48*1*1*8] = { 
  /* [0][0][][] */ -31,-3,127,-29,-3,62,4,-65, 
  /* [1][0][][] */ 87,-55,68,-75,-24,-70,127,21, 
  /* [2][0][][] */ 47,58,78,-89,-75,38,127,-18, 
  /* [3][0][][] */ -28,21,15,-29,25,-49,127,9, 
  /* [4][0][][] */ 125,-102,-64,-75,-114,-44,-11,127, 
  /* [5][0][][] */ 46,83,127,8,30,-54,22,-55, 
  /* [6][0][][] */ 100,103,-10,127,-85,49,53,119, 
  /* [7][0][][] */ 1,6,-15,48,32,-124,-127,-44, 
  /* [8][0][][] */ 115,63,-56,97,-62,-6,-127,-79, 
  /* [9][0][][] */ 127,-36,-35,53,10,-45,19,-81, 
  /* [10][0][][] */ 64,23,0,12,-23,127,27,10, 
  /* [11][0][][] */ 71,-39,17,-127,74,-27,-19,77, 
  /* [12][0][][] */ -60,99,85,-42,26,82,-75,127, 
  /* [13][0][][] */ 127,-9,-77,6,17,-72,13,-94, 
  /* [14][0][][] */ 76,18,25,-24,-127,38,-40,7, 
  /* [15][0][][] */ 17,0,-127,-39,-117,-47,91,103, 
  /* [16][0][][] */ -10,-56,109,-20,127,-30,-54,-18, 
  /* [17][0][][] */ 25,-28,102,-25,127,-39,-81,-7, 
  /* [18][0][][] */ 116,-35,127,45,-40,21,-43,-9, 
  /* [19][0][][] */ 46,73,75,-61,-54,-127,36,-71, 
  /* [20][0][][] */ 45,-29,51,127,2,-66,-70,70, 
  /* [21][0][][] */ 60,-19,-54,-127,41,-52,51,121, 
  /* [22][0][][] */ -86,-109,-19,-64,37,-3,127,-31, 
  /* [23][0][][] */ -47,1,47,-49,-127,-109,21,-23, 
  /* [24][0][][] */ 127,-5,42,37,-10,-15,-81,73, 
  /* [25][0][][] */ 80,46,-5,-96,-3,21,-18,127, 
  /* [26][0][][] */ -63,-33,25,-127,85,14,-34,-56, 
  /* [27][0][][] */ 109,127,2,-66,18,69,12,11, 
  /* [28][0][][] */ 0,125,20,19,11,-24,23,127, 
  /* [29][0][][] */ 112,26,58,98,34,-61,-127,31, 
  /* [30][0][][] */ 127,-106,-71,87,46,13,-73,90, 
  /* [31][0][][] */ 73,-104,29,32,-87,-87,-127,77, 
  /* [32][0][][] */ -127,-50,38,-115,77,-21,-28,-84, 
  /* [33][0][][] */ 7,-1,31,24,19,-62,127,43, 
  /* [34][0][][] */ -114,26,127,-112,126,-31,-19,126, 
  /* [35][0][][] */ -120,-4,15,101,-13,127,-3,-29, 
  /* [36][0][][] */ 54,13,-14,-127,38,2,39,62, 
  /* [37][0][][] */ 26,41,-4,9,-67,127,49,47, 
  /* [38][0][][] */ -3,-78,7,99,12,40,-1,127, 
  /* [39][0][][] */ 4,-10,-127,28,0,-19,-25,79, 
  /* [40][0][][] */ 25,-4,-91,-4,-40,58,-36,127, 
  /* [41][0][][] */ 43,12,26,-57,-125,-127,-18,13, 
  /* [42][0][][] */ -79,58,-84,96,-18,82,-30,-127, 
  /* [43][0][][] */ -29,-2,-15,-127,-5,21,0,-60, 
  /* [44][0][][] */ 71,43,40,65,7,127,-54,44, 
  /* [45][0][][] */ 4,83,-24,22,127,-32,-77,-17, 
  /* [46][0][][] */ 67,-93,16,127,92,53,-52,100, 
  /* [47][0][][] */ -16,-127,46,-38,120,10,28,57, 
};
const TfArray<4, int> tensor_dimension38 = { 4, { 48,1,1,8 } };
const TfArray<48, float> quant38_scale = { 48, { 0.0028883428312838078, 0.0027463182341307402, 0.0019853236153721809, 0.003283908125013113, 0.0012531500542536378, 0.0020540545228868723, 0.0016886392841115594, 0.0016860734904184937, 0.0023119703400880098, 0.0028346048202365637, 0.0031087202951312065, 0.0011391756124794483, 0.0015528483781963587, 0.0024011770728975534, 0.0014765008818358183, 0.0016930537531152368, 0.0023436201736330986, 0.00096921098884195089, 0.0027681093197315931, 0.0015949937514960766, 0.0030299045611172915, 0.00062340800650417805, 0.0013791332021355629, 0.0033227771054953337, 0.0026463379617780447, 0.0019557999912649393, 0.0023025833070278168, 0.0020965978037565947, 0.0028498300816863775, 0.0033600113820284605, 0.0014029836747795343, 0.00063223089091479778, 0.0020944313146173954, 0.0037799335550516844, 0.0010420704493299127, 0.0029381860513240099, 0.001572959590703249, 0.0022401539608836174, 0.0021169378887861967, 0.0026459277141839266, 0.0016914885491132736, 0.0037611797451972961, 0.0010851714760065079, 0.0039740633219480515, 0.0030463109724223614, 0.0022038498427718878, 0.002434795256704092, 0.0012449593050405383, } };
const TfArray<48, int> quant38_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant38 = { (TfLiteFloatArray*)&quant38_scale, (TfLiteIntArray*)&quant38_zero, 0 };
const ALIGN(16) int32_t tensor_data39[48] = { 2364, -2223, 6459, 3142, 6915, -351, 3549, 5814, -2878, -1772, -1343, 12126, 5805, 2960, 9567, -3989, -3462, 14333, 3818, 7756, 3544, 25374, 12219, 1370, -2438, 3208, -1136, -1542, 2765, 1384, 6781, 22734, -1287, 834, 15447, 3812, 9395, 4786, 2142, -1916, 6887, -1908, 12099, -502, 831, 3454, -2481, 8848, };
const TfArray<1, int> tensor_dimension39 = { 1, { 48 } };
const TfArray<48, float> quant39_scale = { 48, { 0.00019359072030056268, 0.00018407154129818082, 0.0001330660015810281, 0.00022010342217981815, 8.3992184954695404e-05, 0.00013767268683295697, 0.00011318078031763434, 0.0001130088057834655, 0.0001549594453535974, 0.00018998894665855914, 0.00020836148178204894, 7.635306246811524e-05, 0.00010407941590528935, 0.00016093850717879832, 9.8962234915234149e-05, 0.00011347665713401511, 0.00015708076534792781, 6.4961212046910077e-05, 0.00018553208792582154, 0.00010690420458558947, 0.00020307887461967766, 4.1783823689911515e-05, 9.2436188424471766e-05, 0.00022270860790740699, 0.00017737038433551788, 0.00013108718849252909, 0.00015433027874678373, 0.00014052413462195545, 0.0001910094142658636, 0.00022520423226524144, 9.403475996805355e-05, 4.2375177145004272e-05, 0.00014037892105989158, 0.00025334945530630648, 6.9844609242863953e-05, 0.00019693146168719977, 0.00010542736708885059, 0.00015014596283435822, 0.000141887430800125, 0.00017734288121573627, 0.00011337175237713382, 0.00025209248997271061, 7.2733448178041726e-05, 0.00026636096299625933, 0.00020417850464582443, 0.00014771269343327731, 0.00016319176938850433, 8.3443199400790036e-05, } };
const TfArray<48, int> quant39_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant39 = { (TfLiteFloatArray*)&quant39_scale, (TfLiteIntArray*)&quant39_zero, 0 };
const ALIGN(16) int8_t tensor_data40[32*1*1*48] = { 
  /* [0][0][][] */ -6,29,-1,-97,-48,16,9,59,39,21,-103,-83,-110,127,-19,53,24,61,22,27,-28,-101,-63,40,97,-91,-17,91,55,-36,56,4,-82,51,-12,-95,-55,-18,-92,2,-113,21,78,-53,38,-3,-66,57, 
  /* [1][0][][] */ 45,-21,39,24,2,-31,6,108,67,87,-87,26,-127,-44,26,-70,-41,-25,10,-1,87,49,-79,-38,18,-39,-46,-60,66,58,-22,-42,-93,-54,-114,-91,-10,-79,-74,14,-38,118,5,15,1,29,-38,-10, 
  /* [2][0][][] */ 25,124,-51,-62,-7,17,64,19,11,-48,-21,4,75,70,-46,-66,-43,65,-20,41,-53,-7,67,34,-10,110,7,-33,-11,-25,-32,51,86,-19,94,43,-22,51,32,73,100,-35,116,83,-8,2,127,89, 
  /* [3][0][][] */ -98,89,47,-89,86,84,59,52,84,8,29,-77,91,27,85,100,-127,47,-78,83,-91,57,-93,-14,87,67,-119,7,37,14,-63,86,-105,21,9,-105,-104,-47,-70,-68,-97,-58,-79,9,-87,-122,-48,-38, 
  /* [4][0][][] */ -52,46,104,20,84,2,0,-48,-28,38,-71,-33,-28,82,39,-74,111,50,-19,-71,-81,93,-79,-31,-5,-85,118,57,32,-120,123,45,-49,72,-18,4,113,12,-60,-76,127,74,-94,-76,11,78,-5,2, 
  /* [5][0][][] */ -127,68,-65,-81,-2,-15,-44,24,13,-55,17,0,-101,39,76,87,-117,76,56,-9,71,-32,-88,100,-121,7,-58,-62,-39,26,27,-42,-89,32,24,12,52,-91,-82,-47,29,21,-57,-68,61,87,-16,-37, 
  /* [6][0][][] */ 125,5,31,-48,-65,-12,73,-66,-38,30,49,127,73,-60,1,124,-30,107,54,94,-75,122,111,44,-32,69,-62,-70,-16,-82,23,68,-42,44,95,107,-66,-16,32,74,-45,-2,92,33,-69,84,-54,5, 
  /* [7][0][][] */ 71,52,-21,-47,116,-39,-9,-53,-32,-103,28,30,25,45,74,70,84,29,-15,24,57,-19,41,-52,94,-10,83,96,-25,-38,25,28,-41,47,113,34,127,37,53,-9,-2,-13,-43,70,52,-58,-25,19, 
  /* [8][0][][] */ -72,-70,-123,-26,44,-23,-38,-113,77,-125,103,-113,-43,-115,-127,-13,3,59,64,-87,79,43,76,-78,-69,-102,-3,-96,-88,-96,-114,-21,-59,-24,-105,92,-127,-112,-66,-81,-34,23,24,-40,-22,-71,-36,73, 
  /* [9][0][][] */ -41,-47,16,76,16,50,75,30,0,33,59,56,104,47,-42,-36,52,-59,-80,-89,-100,79,23,-35,-97,-73,-32,42,63,-127,-38,42,-80,-65,120,-19,-34,-10,-67,-79,99,74,-1,-4,37,61,12,-10, 
  /* [10][0][][] */ -102,25,-88,-99,-59,73,-127,-104,62,-109,60,47,-25,17,52,-21,83,-3,-94,23,-24,-74,-56,69,14,83,-45,-42,-116,-87,-30,-117,42,23,86,-125,91,-96,20,90,61,16,17,39,-34,17,-24,-24, 
  /* [11][0][][] */ 52,37,-84,-98,60,-31,-60,-101,-101,22,15,-31,-1,-87,25,-93,-122,45,-40,-68,-60,-59,38,-90,-107,66,40,55,-17,20,-21,15,27,54,-127,-88,-11,84,-72,-86,25,-116,75,-120,55,5,-113,-42, 
  /* [12][0][][] */ -3,-9,-14,127,34,-3,-10,-28,-79,-52,-7,62,-21,-66,0,79,62,4,60,114,-44,11,92,62,10,95,-26,31,105,-57,83,92,62,6,40,0,41,-27,84,68,97,38,77,-25,57,12,-26,97, 
  /* [13][0][][] */ 30,22,55,-84,74,0,12,-80,-5,-127,13,6,-33,60,13,49,49,27,-23,58,84,-37,-31,-92,63,-97,-25,-93,7,-118,-72,-34,-40,-122,4,-28,43,-124,48,18,-38,-84,43,61,29,-34,39,40, 
  /* [14][0][][] */ -5,-36,96,75,65,-56,35,9,-34,43,-6,-34,26,99,-2,48,-39,2,6,-65,15,56,-12,-16,-16,0,88,36,81,-61,83,-13,3,103,127,59,47,83,-51,-58,110,86,119,44,87,-44,19,-12, 
  /* [15][0][][] */ 0,29,-25,-85,-107,64,-12,31,-93,-44,83,-57,-34,-72,-67,-53,-51,66,-117,-9,-46,-103,-76,-53,-18,-24,75,92,-37,-94,-127,2,35,76,-62,-45,-48,78,-48,-95,-76,82,79,-79,61,29,-90,-106, 
  /* [16][0][][] */ -23,10,-105,83,63,-68,72,83,-30,33,63,-77,-60,68,-122,-38,17,55,-67,-37,-127,-38,-118,-1,81,-72,-69,9,-63,82,83,13,-91,-68,-5,-20,-27,69,-118,41,27,31,56,-59,-100,-22,-114,-73, 
  /* [17][0][][] */ -24,71,-101,-42,-26,42,-21,85,67,18,51,-23,-56,105,34,-87,19,60,-11,65,24,-25,-71,-7,-69,-40,-58,-63,-21,60,54,-79,15,-26,-57,-8,7,-110,-66,35,-90,127,-26,-87,69,27,-67,-113, 
  /* [18][0][][] */ 90,-120,-116,-35,93,19,-90,-102,-54,68,-85,-72,-17,111,41,19,38,97,-62,-41,-85,54,28,32,43,-61,37,-120,-50,-121,53,-106,-34,93,91,-70,31,-62,-96,-77,-127,39,116,-60,-19,40,114,-66, 
  /* [19][0][][] */ 22,26,-102,49,90,80,-46,13,115,-1,-17,-72,22,92,105,-43,12,-113,-27,109,-90,-105,-20,110,60,-34,-11,-24,67,59,79,-108,25,-36,-121,26,-127,-46,-90,23,25,61,25,17,-62,49,-104,56, 
  /* [20][0][][] */ 42,-51,26,96,114,52,105,74,-109,-105,47,37,13,-59,38,-42,23,-11,126,69,80,-58,127,19,-65,125,-27,48,37,-47,-11,44,81,119,113,-1,127,53,-58,49,122,-107,-33,24,71,40,-8,0, 
  /* [21][0][][] */ 50,90,84,-93,-43,-59,-92,-60,-40,82,5,-104,-71,-85,-106,-104,-49,-38,-88,-113,-48,35,84,-63,82,17,53,-26,-67,-109,82,-12,-111,14,73,79,-123,-98,-125,7,-14,37,-57,-9,-87,76,-127,47, 
  /* [22][0][][] */ 48,-17,93,18,-13,-57,105,68,-33,-63,15,68,12,19,13,-41,-14,36,-19,75,61,127,51,77,-40,78,22,69,-3,-67,-20,-14,21,111,85,110,76,-21,-4,-22,44,-57,-18,68,84,-20,124,7, 
  /* [23][0][][] */ -67,-20,-23,-67,-107,-9,26,-13,95,-28,26,-119,-127,70,33,-71,2,12,21,-1,21,60,22,-31,27,-72,-92,-80,-112,58,-28,75,41,-85,63,-55,-31,68,41,-94,75,86,58,-119,-111,-19,-107,65, 
  /* [24][0][][] */ -35,51,58,51,27,-25,-93,70,42,-41,-88,51,-4,20,-26,-67,-34,14,-66,53,80,-44,-48,21,-39,28,-76,-62,51,93,62,-43,72,-61,-36,-52,-12,-66,-89,-93,-23,127,-91,7,-56,53,24,-75, 
  /* [25][0][][] */ 18,18,20,87,26,32,-45,54,-67,22,71,67,-42,63,89,-51,0,15,-45,23,72,105,11,90,51,-35,-6,-21,75,60,-52,75,-18,-26,103,127,-56,71,-50,108,-45,62,76,41,20,-49,-54,-53, 
  /* [26][0][][] */ 98,-32,35,32,100,-68,91,-6,-19,-74,-34,39,5,-77,63,-1,101,36,-25,-45,54,0,91,69,18,11,68,56,44,-10,-10,7,15,63,72,127,41,105,-57,92,110,-33,12,-35,26,46,107,42, 
  /* [27][0][][] */ 37,23,-121,94,-45,-43,-9,-20,-100,69,-45,-26,-127,54,60,-62,16,-126,-27,-119,-40,35,60,-100,-126,51,-60,34,70,-73,43,-126,77,-97,16,79,86,38,-92,-55,15,38,-42,41,45,-102,79,-86, 
  /* [28][0][][] */ -122,78,-65,43,-11,69,-111,-19,127,-13,-108,46,32,-67,0,-110,-80,45,13,66,69,42,-15,-80,40,-80,42,74,-65,11,-37,14,-46,-6,-54,-74,9,60,-55,80,-104,9,-24,29,69,81,-34,-20, 
  /* [29][0][][] */ 0,-39,14,-2,-44,-15,2,-125,-50,-37,-52,-97,47,-39,-93,-40,67,69,-84,73,8,-82,-100,-106,68,-76,-109,-60,-63,64,-76,6,-111,88,83,-23,-43,-106,4,-44,89,-66,-39,16,-91,38,-127,-16, 
  /* [30][0][][] */ -90,-127,-122,-74,43,109,64,1,-48,76,-3,44,74,86,-121,-117,89,108,79,7,-18,-107,112,-80,12,22,-53,7,59,-46,-7,38,-16,-34,-2,13,-122,-73,58,-16,-50,-117,-86,-117,63,124,-64,-63, 
  /* [31][0][][] */ 79,119,96,15,-6,7,96,-35,-112,-87,80,-9,-24,-89,108,35,22,72,13,39,7,10,120,10,75,107,6,-21,21,59,74,93,95,61,87,127,82,127,20,-40,41,42,-31,68,54,90,61,31, 
};
const TfArray<4, int> tensor_dimension40 = { 4, { 32,1,1,48 } };
const TfArray<32, float> quant40_scale = { 32, { 0.0029671541415154934, 0.0031534505542367697, 0.0027158879674971104, 0.002389546949416399, 0.0024272026494145393, 0.0026742015033960342, 0.0026638144627213478, 0.0033772774040699005, 0.0023617146071046591, 0.0022126724943518639, 0.0024063289165496826, 0.0025076458696275949, 0.0031817466951906681, 0.0025010264944285154, 0.0027557550929486752, 0.0024644318036735058, 0.0025293515063822269, 0.0029038470238447189, 0.0021878641564399004, 0.0025350272189825773, 0.0027386576402932405, 0.0024235097225755453, 0.0034477391745895147, 0.0025738787371665239, 0.0028537074103951454, 0.0030558847356587648, 0.0031903437338769436, 0.0024361838586628437, 0.0027184304781258106, 0.0024363782722502947, 0.0021168089006096125, 0.0029168885666877031, } };
const TfArray<32, int> quant40_zero = { 32, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant40 = { (TfLiteFloatArray*)&quant40_scale, (TfLiteIntArray*)&quant40_zero, 0 };
const ALIGN(16) int32_t tensor_data41[32] = { -1344, -156, 1798, -1180, 1018, -2385, 1872, 1307, -972, -265, -959, -1236, 2467, -1238, 1526, -1291, -1126, -580, -189, -1954, 2310, -1344, 3003, -1636, -1596, 1614, 2116, -991, -1219, -1124, -932, 2339, };
const TfArray<1, int> tensor_dimension41 = { 1, { 32 } };
const TfArray<32, float> quant41_scale = { 32, { 5.1738625188590959e-05, 5.498710015672259e-05, 4.7357265430036932e-05, 4.1666819015517831e-05, 4.2323426896473393e-05, 4.6630375436507165e-05, 4.6449255023617297e-05, 5.8889992942567915e-05, 4.1181501728715375e-05, 3.8582638808293268e-05, 4.1959447116823867e-05, 4.3726122385123745e-05, 5.5480501032434404e-05, 4.3610700231511146e-05, 4.8052435886347666e-05, 4.2972595110768452e-05, 4.4104606786277145e-05, 5.0634731451282278e-05, 3.81500503863208e-05, 4.4203574361745268e-05, 4.7754303523106501e-05, 4.2259031033609062e-05, 6.0118643887108192e-05, 4.488103513722308e-05, 4.9760441470425576e-05, 5.3285832109395415e-05, 5.5630407587159425e-05, 4.248003097018227e-05, 4.7401601477758959e-05, 4.2483421566430479e-05, 3.6911053030053154e-05, 5.0862137868534774e-05, } };
const TfArray<32, int> quant41_zero = { 32, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant41 = { (TfLiteFloatArray*)&quant41_scale, (TfLiteIntArray*)&quant41_zero, 0 };
const ALIGN(16) int8_t tensor_data42[2*1*1*32] = { 
  /* [0][0][][] */ -47,-50,12,-29,60,10,90,31,34,-51,-55,-28,70,-8,89,-6,-59,-34,62,10,73,-15,127,-28,-21,68,28,-61,-41,-47,25,25, 
  /* [1][0][][] */ 100,127,-98,-49,13,67,-23,-76,47,-88,-84,33,-88,-14,0,55,-59,97,51,73,-97,-16,-43,24,77,-14,-102,-85,37,58,79,-120, 
};
const TfArray<4, int> tensor_dimension42 = { 4, { 2,1,1,32 } };
const TfArray<2, float> quant42_scale = { 2, { 0.0055685443803668022, 0.004368969239294529, } };
const TfArray<2, int> quant42_zero = { 2, { 0,0 } };
const TfLiteAffineQuantization quant42 = { (TfLiteFloatArray*)&quant42_scale, (TfLiteIntArray*)&quant42_zero, 0 };
const ALIGN(8) int32_t tensor_data43[2] = { 364, -785, };
const TfArray<1, int> tensor_dimension43 = { 1, { 2 } };
const TfArray<2, float> quant43_scale = { 2, { 0.00020033257897011936, 0.00015717696805950254, } };
const TfArray<2, int> quant43_zero = { 2, { 0,0 } };
const TfLiteAffineQuantization quant43 = { (TfLiteFloatArray*)&quant43_scale, (TfLiteIntArray*)&quant43_zero, 0 };
const TfArray<4, int> tensor_dimension44 = { 4, { 1,48,48,8 } };
const TfArray<1, float> quant44_scale = { 1, { 0.023529412224888802, } };
const TfArray<1, int> quant44_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant44 = { (TfLiteFloatArray*)&quant44_scale, (TfLiteIntArray*)&quant44_zero, 0 };
const TfArray<4, int> tensor_dimension45 = { 4, { 1,48,48,8 } };
const TfArray<1, float> quant45_scale = { 1, { 0.023529412224888802, } };
const TfArray<1, int> quant45_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant45 = { (TfLiteFloatArray*)&quant45_scale, (TfLiteIntArray*)&quant45_zero, 0 };
const TfArray<4, int> tensor_dimension46 = { 4, { 1,48,48,8 } };
const TfArray<1, float> quant46_scale = { 1, { 0.066521614789962769, } };
const TfArray<1, int> quant46_zero = { 1, { 33 } };
const TfLiteAffineQuantization quant46 = { (TfLiteFloatArray*)&quant46_scale, (TfLiteIntArray*)&quant46_zero, 0 };
const TfArray<4, int> tensor_dimension47 = { 4, { 1,48,48,8 } };
const TfArray<1, float> quant47_scale = { 1, { 0.080466791987419128, } };
const TfArray<1, int> quant47_zero = { 1, { 5 } };
const TfLiteAffineQuantization quant47 = { (TfLiteFloatArray*)&quant47_scale, (TfLiteIntArray*)&quant47_zero, 0 };
const TfArray<4, int> tensor_dimension48 = { 4, { 1,48,48,48 } };
const TfArray<1, float> quant48_scale = { 1, { 0.023529412224888802, } };
const TfArray<1, int> quant48_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant48 = { (TfLiteFloatArray*)&quant48_scale, (TfLiteIntArray*)&quant48_zero, 0 };
const TfArray<4, int> tensor_dimension49 = { 4, { 1,49,49,48 } };
const TfArray<1, float> quant49_scale = { 1, { 0.023529412224888802, } };
const TfArray<1, int> quant49_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant49 = { (TfLiteFloatArray*)&quant49_scale, (TfLiteIntArray*)&quant49_zero, 0 };
const TfArray<4, int> tensor_dimension50 = { 4, { 1,24,24,48 } };
const TfArray<1, float> quant50_scale = { 1, { 0.023529412224888802, } };
const TfArray<1, int> quant50_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant50 = { (TfLiteFloatArray*)&quant50_scale, (TfLiteIntArray*)&quant50_zero, 0 };
const TfArray<4, int> tensor_dimension51 = { 4, { 1,24,24,8 } };
const TfArray<1, float> quant51_scale = { 1, { 0.047693178057670593, } };
const TfArray<1, int> quant51_zero = { 1, { 13 } };
const TfLiteAffineQuantization quant51 = { (TfLiteFloatArray*)&quant51_scale, (TfLiteIntArray*)&quant51_zero, 0 };
const TfArray<4, int> tensor_dimension52 = { 4, { 1,24,24,48 } };
const TfArray<1, float> quant52_scale = { 1, { 0.023529412224888802, } };
const TfArray<1, int> quant52_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant52 = { (TfLiteFloatArray*)&quant52_scale, (TfLiteIntArray*)&quant52_zero, 0 };
const TfArray<4, int> tensor_dimension53 = { 4, { 1,24,24,48 } };
const TfArray<1, float> quant53_scale = { 1, { 0.023529412224888802, } };
const TfArray<1, int> quant53_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant53 = { (TfLiteFloatArray*)&quant53_scale, (TfLiteIntArray*)&quant53_zero, 0 };
const TfArray<4, int> tensor_dimension54 = { 4, { 1,24,24,8 } };
const TfArray<1, float> quant54_scale = { 1, { 0.11802394688129425, } };
const TfArray<1, int> quant54_zero = { 1, { -13 } };
const TfLiteAffineQuantization quant54 = { (TfLiteFloatArray*)&quant54_scale, (TfLiteIntArray*)&quant54_zero, 0 };
const TfArray<4, int> tensor_dimension55 = { 4, { 1,24,24,8 } };
const TfArray<1, float> quant55_scale = { 1, { 0.11501118540763855, } };
const TfArray<1, int> quant55_zero = { 1, { -19 } };
const TfLiteAffineQuantization quant55 = { (TfLiteFloatArray*)&quant55_scale, (TfLiteIntArray*)&quant55_zero, 0 };
const TfArray<4, int> tensor_dimension56 = { 4, { 1,24,24,48 } };
const TfArray<1, float> quant56_scale = { 1, { 0.023242205381393433, } };
const TfArray<1, int> quant56_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant56 = { (TfLiteFloatArray*)&quant56_scale, (TfLiteIntArray*)&quant56_zero, 0 };
const TfArray<4, int> tensor_dimension57 = { 4, { 1,25,25,48 } };
const TfArray<1, float> quant57_scale = { 1, { 0.023242205381393433, } };
const TfArray<1, int> quant57_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant57 = { (TfLiteFloatArray*)&quant57_scale, (TfLiteIntArray*)&quant57_zero, 0 };
const TfArray<4, int> tensor_dimension58 = { 4, { 1,12,12,48 } };
const TfArray<1, float> quant58_scale = { 1, { 0.023529412224888802, } };
const TfArray<1, int> quant58_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant58 = { (TfLiteFloatArray*)&quant58_scale, (TfLiteIntArray*)&quant58_zero, 0 };
const TfArray<4, int> tensor_dimension59 = { 4, { 1,12,12,8 } };
const TfArray<1, float> quant59_scale = { 1, { 0.044900946319103241, } };
const TfArray<1, int> quant59_zero = { 1, { -1 } };
const TfLiteAffineQuantization quant59 = { (TfLiteFloatArray*)&quant59_scale, (TfLiteIntArray*)&quant59_zero, 0 };
const TfArray<4, int> tensor_dimension60 = { 4, { 1,12,12,48 } };
const TfArray<1, float> quant60_scale = { 1, { 0.017969733104109764, } };
const TfArray<1, int> quant60_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant60 = { (TfLiteFloatArray*)&quant60_scale, (TfLiteIntArray*)&quant60_zero, 0 };
const TfArray<4, int> tensor_dimension61 = { 4, { 1,12,12,48 } };
const TfArray<1, float> quant61_scale = { 1, { 0.023529412224888802, } };
const TfArray<1, int> quant61_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant61 = { (TfLiteFloatArray*)&quant61_scale, (TfLiteIntArray*)&quant61_zero, 0 };
const TfArray<4, int> tensor_dimension62 = { 4, { 1,12,12,8 } };
const TfArray<1, float> quant62_scale = { 1, { 0.035791516304016113, } };
const TfArray<1, int> quant62_zero = { 1, { -9 } };
const TfLiteAffineQuantization quant62 = { (TfLiteFloatArray*)&quant62_scale, (TfLiteIntArray*)&quant62_zero, 0 };
const TfArray<4, int> tensor_dimension63 = { 4, { 1,12,12,8 } };
const TfArray<1, float> quant63_scale = { 1, { 0.047244757413864136, } };
const TfArray<1, int> quant63_zero = { 1, { 0 } };
const TfLiteAffineQuantization quant63 = { (TfLiteFloatArray*)&quant63_scale, (TfLiteIntArray*)&quant63_zero, 0 };
const TfArray<4, int> tensor_dimension64 = { 4, { 1,12,12,48 } };
const TfArray<1, float> quant64_scale = { 1, { 0.015320358797907829, } };
const TfArray<1, int> quant64_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant64 = { (TfLiteFloatArray*)&quant64_scale, (TfLiteIntArray*)&quant64_zero, 0 };
const TfArray<4, int> tensor_dimension65 = { 4, { 1,12,12,48 } };
const TfArray<1, float> quant65_scale = { 1, { 0.02013680711388588, } };
const TfArray<1, int> quant65_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant65 = { (TfLiteFloatArray*)&quant65_scale, (TfLiteIntArray*)&quant65_zero, 0 };
const TfArray<4, int> tensor_dimension66 = { 4, { 1,12,12,8 } };
const TfArray<1, float> quant66_scale = { 1, { 0.038139559328556061, } };
const TfArray<1, int> quant66_zero = { 1, { 22 } };
const TfLiteAffineQuantization quant66 = { (TfLiteFloatArray*)&quant66_scale, (TfLiteIntArray*)&quant66_zero, 0 };
const TfArray<4, int> tensor_dimension67 = { 4, { 1,12,12,8 } };
const TfArray<1, float> quant67_scale = { 1, { 0.067024841904640198, } };
const TfArray<1, int> quant67_zero = { 1, { 12 } };
const TfLiteAffineQuantization quant67 = { (TfLiteFloatArray*)&quant67_scale, (TfLiteIntArray*)&quant67_zero, 0 };
const TfArray<4, int> tensor_dimension68 = { 4, { 1,12,12,48 } };
const TfArray<1, float> quant68_scale = { 1, { 0.017437120899558067, } };
const TfArray<1, int> quant68_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant68 = { (TfLiteFloatArray*)&quant68_scale, (TfLiteIntArray*)&quant68_zero, 0 };
const TfArray<4, int> tensor_dimension69 = { 4, { 1,12,12,32 } };
const TfArray<1, float> quant69_scale = { 1, { 0.035975754261016846, } };
const TfArray<1, int> quant69_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant69 = { (TfLiteFloatArray*)&quant69_scale, (TfLiteIntArray*)&quant69_zero, 0 };
const TfArray<4, int> tensor_dimension70 = { 4, { 1,12,12,2 } };
const TfArray<1, float> quant70_scale = { 1, { 0.15252508223056793, } };
const TfArray<1, int> quant70_zero = { 1, { -5 } };
const TfLiteAffineQuantization quant70 = { (TfLiteFloatArray*)&quant70_scale, (TfLiteIntArray*)&quant70_zero, 0 };
const TfArray<4, int> tensor_dimension71 = { 4, { 1,12,12,2 } };
const TfArray<1, float> quant71_scale = { 1, { 0.00390625, } };
const TfArray<1, int> quant71_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant71 = { (TfLiteFloatArray*)&quant71_scale, (TfLiteIntArray*)&quant71_zero, 0 };
const TfLiteConvParams opdata0 = { kTfLitePaddingSame, 2,2, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs0 = { 3, { 0,2,3 } };
const TfArray<1, int> outputs0 = { 1, { 44 } };
const TfLiteDepthwiseConvParams opdata1 = { kTfLitePaddingSame, 1,1, 1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs1 = { 3, { 44,4,5 } };
const TfArray<1, int> outputs1 = { 1, { 45 } };
const TfLiteConvParams opdata2 = { kTfLitePaddingSame, 1,1, kTfLiteActNone, 1,1 };
const TfArray<3, int> inputs2 = { 3, { 45,6,7 } };
const TfArray<1, int> outputs2 = { 1, { 46 } };
const TfLiteAddParams opdata3 = { kTfLiteActNone };
const TfArray<2, int> inputs3 = { 2, { 44,46 } };
const TfArray<1, int> outputs3 = { 1, { 47 } };
const TfLiteConvParams opdata4 = { kTfLitePaddingSame, 1,1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs4 = { 3, { 47,8,9 } };
const TfArray<1, int> outputs4 = { 1, { 48 } };
const TfArray<2, int> inputs5 = { 2, { 48,1 } };
const TfArray<1, int> outputs5 = { 1, { 49 } };
const TfLiteDepthwiseConvParams opdata6 = { kTfLitePaddingValid, 2,2, 1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs6 = { 3, { 49,10,11 } };
const TfArray<1, int> outputs6 = { 1, { 50 } };
const TfLiteConvParams opdata7 = { kTfLitePaddingSame, 1,1, kTfLiteActNone, 1,1 };
const TfArray<3, int> inputs7 = { 3, { 50,12,13 } };
const TfArray<1, int> outputs7 = { 1, { 51 } };
const TfLiteConvParams opdata8 = { kTfLitePaddingSame, 1,1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs8 = { 3, { 51,14,15 } };
const TfArray<1, int> outputs8 = { 1, { 52 } };
const TfLiteDepthwiseConvParams opdata9 = { kTfLitePaddingSame, 1,1, 1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs9 = { 3, { 52,16,17 } };
const TfArray<1, int> outputs9 = { 1, { 53 } };
const TfLiteConvParams opdata10 = { kTfLitePaddingSame, 1,1, kTfLiteActNone, 1,1 };
const TfArray<3, int> inputs10 = { 3, { 53,18,19 } };
const TfArray<1, int> outputs10 = { 1, { 54 } };
const TfLiteAddParams opdata11 = { kTfLiteActNone };
const TfArray<2, int> inputs11 = { 2, { 51,54 } };
const TfArray<1, int> outputs11 = { 1, { 55 } };
const TfLiteConvParams opdata12 = { kTfLitePaddingSame, 1,1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs12 = { 3, { 55,20,21 } };
const TfArray<1, int> outputs12 = { 1, { 56 } };
const TfArray<2, int> inputs13 = { 2, { 56,1 } };
const TfArray<1, int> outputs13 = { 1, { 57 } };
const TfLiteDepthwiseConvParams opdata14 = { kTfLitePaddingValid, 2,2, 1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs14 = { 3, { 57,22,23 } };
const TfArray<1, int> outputs14 = { 1, { 58 } };
const TfLiteConvParams opdata15 = { kTfLitePaddingSame, 1,1, kTfLiteActNone, 1,1 };
const TfArray<3, int> inputs15 = { 3, { 58,24,25 } };
const TfArray<1, int> outputs15 = { 1, { 59 } };
const TfLiteConvParams opdata16 = { kTfLitePaddingSame, 1,1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs16 = { 3, { 59,26,27 } };
const TfArray<1, int> outputs16 = { 1, { 60 } };
const TfLiteDepthwiseConvParams opdata17 = { kTfLitePaddingSame, 1,1, 1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs17 = { 3, { 60,28,29 } };
const TfArray<1, int> outputs17 = { 1, { 61 } };
const TfLiteConvParams opdata18 = { kTfLitePaddingSame, 1,1, kTfLiteActNone, 1,1 };
const TfArray<3, int> inputs18 = { 3, { 61,30,31 } };
const TfArray<1, int> outputs18 = { 1, { 62 } };
const TfLiteAddParams opdata19 = { kTfLiteActNone };
const TfArray<2, int> inputs19 = { 2, { 59,62 } };
const TfArray<1, int> outputs19 = { 1, { 63 } };
const TfLiteConvParams opdata20 = { kTfLitePaddingSame, 1,1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs20 = { 3, { 63,32,33 } };
const TfArray<1, int> outputs20 = { 1, { 64 } };
const TfLiteDepthwiseConvParams opdata21 = { kTfLitePaddingSame, 1,1, 1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs21 = { 3, { 64,34,35 } };
const TfArray<1, int> outputs21 = { 1, { 65 } };
const TfLiteConvParams opdata22 = { kTfLitePaddingSame, 1,1, kTfLiteActNone, 1,1 };
const TfArray<3, int> inputs22 = { 3, { 65,36,37 } };
const TfArray<1, int> outputs22 = { 1, { 66 } };
const TfLiteAddParams opdata23 = { kTfLiteActNone };
const TfArray<2, int> inputs23 = { 2, { 63,66 } };
const TfArray<1, int> outputs23 = { 1, { 67 } };
const TfLiteConvParams opdata24 = { kTfLitePaddingSame, 1,1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs24 = { 3, { 67,38,39 } };
const TfArray<1, int> outputs24 = { 1, { 68 } };
const TfLiteConvParams opdata25 = { kTfLitePaddingValid, 1,1, kTfLiteActRelu, 1,1 };
const TfArray<3, int> inputs25 = { 3, { 68,40,41 } };
const TfArray<1, int> outputs25 = { 1, { 69 } };
const TfLiteConvParams opdata26 = { kTfLitePaddingValid, 1,1, kTfLiteActNone, 1,1 };
const TfArray<3, int> inputs26 = { 3, { 69,42,43 } };
const TfArray<1, int> outputs26 = { 1, { 70 } };
const TfLiteSoftmaxParams opdata27 = { 1 };
const TfArray<1, int> inputs27 = { 1, { 70 } };
const TfArray<1, int> outputs27 = { 1, { 71 } };
const TensorInfo_t tensorData[] = {
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension0, 9216, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant0))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data1, (TfLiteIntArray*)&tensor_dimension1, 32, {kTfLiteNoQuantization, nullptr}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data2, (TfLiteIntArray*)&tensor_dimension2, 72, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant2))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data3, (TfLiteIntArray*)&tensor_dimension3, 32, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant3))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data4, (TfLiteIntArray*)&tensor_dimension4, 72, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant4))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data5, (TfLiteIntArray*)&tensor_dimension5, 32, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant5))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data6, (TfLiteIntArray*)&tensor_dimension6, 64, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant6))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data7, (TfLiteIntArray*)&tensor_dimension7, 32, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant7))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data8, (TfLiteIntArray*)&tensor_dimension8, 384, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant8))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data9, (TfLiteIntArray*)&tensor_dimension9, 192, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant9))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data10, (TfLiteIntArray*)&tensor_dimension10, 432, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant10))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data11, (TfLiteIntArray*)&tensor_dimension11, 192, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant11))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data12, (TfLiteIntArray*)&tensor_dimension12, 384, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant12))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data13, (TfLiteIntArray*)&tensor_dimension13, 32, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant13))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data14, (TfLiteIntArray*)&tensor_dimension14, 384, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant14))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data15, (TfLiteIntArray*)&tensor_dimension15, 192, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant15))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data16, (TfLiteIntArray*)&tensor_dimension16, 432, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant16))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data17, (TfLiteIntArray*)&tensor_dimension17, 192, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant17))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data18, (TfLiteIntArray*)&tensor_dimension18, 384, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant18))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data19, (TfLiteIntArray*)&tensor_dimension19, 32, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant19))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data20, (TfLiteIntArray*)&tensor_dimension20, 384, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant20))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data21, (TfLiteIntArray*)&tensor_dimension21, 192, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant21))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data22, (TfLiteIntArray*)&tensor_dimension22, 432, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant22))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data23, (TfLiteIntArray*)&tensor_dimension23, 192, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant23))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data24, (TfLiteIntArray*)&tensor_dimension24, 384, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant24))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data25, (TfLiteIntArray*)&tensor_dimension25, 32, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant25))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data26, (TfLiteIntArray*)&tensor_dimension26, 384, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant26))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data27, (TfLiteIntArray*)&tensor_dimension27, 192, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant27))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data28, (TfLiteIntArray*)&tensor_dimension28, 432, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant28))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data29, (TfLiteIntArray*)&tensor_dimension29, 192, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant29))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data30, (TfLiteIntArray*)&tensor_dimension30, 384, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant30))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data31, (TfLiteIntArray*)&tensor_dimension31, 32, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant31))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data32, (TfLiteIntArray*)&tensor_dimension32, 384, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant32))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data33, (TfLiteIntArray*)&tensor_dimension33, 192, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant33))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data34, (TfLiteIntArray*)&tensor_dimension34, 432, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant34))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data35, (TfLiteIntArray*)&tensor_dimension35, 192, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant35))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data36, (TfLiteIntArray*)&tensor_dimension36, 384, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant36))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data37, (TfLiteIntArray*)&tensor_dimension37, 32, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant37))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data38, (TfLiteIntArray*)&tensor_dimension38, 384, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant38))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data39, (TfLiteIntArray*)&tensor_dimension39, 192, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant39))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data40, (TfLiteIntArray*)&tensor_dimension40, 1536, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant40))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data41, (TfLiteIntArray*)&tensor_dimension41, 128, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant41))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data42, (TfLiteIntArray*)&tensor_dimension42, 64, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant42))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data43, (TfLiteIntArray*)&tensor_dimension43, 8, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant43))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 36864, (TfLiteIntArray*)&tensor_dimension44, 18432, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant44))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension45, 18432, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant45))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 18432, (TfLiteIntArray*)&tensor_dimension46, 18432, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant46))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension47, 18432, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant47))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 115248, (TfLiteIntArray*)&tensor_dimension48, 110592, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant48))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension49, 115248, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant49))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 115248, (TfLiteIntArray*)&tensor_dimension50, 27648, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant50))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 55296, (TfLiteIntArray*)&tensor_dimension51, 4608, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant51))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 27648, (TfLiteIntArray*)&tensor_dimension52, 27648, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant52))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension53, 27648, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant53))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 27648, (TfLiteIntArray*)&tensor_dimension54, 4608, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant54))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension55, 4608, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant55))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 30000, (TfLiteIntArray*)&tensor_dimension56, 27648, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant56))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension57, 30000, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant57))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 30000, (TfLiteIntArray*)&tensor_dimension58, 6912, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant58))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 14976, (TfLiteIntArray*)&tensor_dimension59, 1152, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant59))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 6912, (TfLiteIntArray*)&tensor_dimension60, 6912, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant60))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension61, 6912, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant61))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 6912, (TfLiteIntArray*)&tensor_dimension62, 1152, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant62))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 13824, (TfLiteIntArray*)&tensor_dimension63, 1152, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant63))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 6912, (TfLiteIntArray*)&tensor_dimension64, 6912, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant64))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension65, 6912, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant65))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 8064, (TfLiteIntArray*)&tensor_dimension66, 1152, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant66))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 6912, (TfLiteIntArray*)&tensor_dimension67, 1152, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant67))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension68, 6912, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant68))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 6912, (TfLiteIntArray*)&tensor_dimension69, 4608, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant69))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 288, (TfLiteIntArray*)&tensor_dimension70, 288, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant70))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension71, 288, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant71))}, },
};const NodeInfo_t nodeData[] = {
  { (TfLiteIntArray*)&inputs0, (TfLiteIntArray*)&outputs0, const_cast<void*>(static_cast<const void*>(&opdata0)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs1, (TfLiteIntArray*)&outputs1, const_cast<void*>(static_cast<const void*>(&opdata1)), OP_DEPTHWISE_CONV_2D, },
  { (TfLiteIntArray*)&inputs2, (TfLiteIntArray*)&outputs2, const_cast<void*>(static_cast<const void*>(&opdata2)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs3, (TfLiteIntArray*)&outputs3, const_cast<void*>(static_cast<const void*>(&opdata3)), OP_ADD, },
  { (TfLiteIntArray*)&inputs4, (TfLiteIntArray*)&outputs4, const_cast<void*>(static_cast<const void*>(&opdata4)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs5, (TfLiteIntArray*)&outputs5, nullptr, OP_PAD, },
  { (TfLiteIntArray*)&inputs6, (TfLiteIntArray*)&outputs6, const_cast<void*>(static_cast<const void*>(&opdata6)), OP_DEPTHWISE_CONV_2D, },
  { (TfLiteIntArray*)&inputs7, (TfLiteIntArray*)&outputs7, const_cast<void*>(static_cast<const void*>(&opdata7)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs8, (TfLiteIntArray*)&outputs8, const_cast<void*>(static_cast<const void*>(&opdata8)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs9, (TfLiteIntArray*)&outputs9, const_cast<void*>(static_cast<const void*>(&opdata9)), OP_DEPTHWISE_CONV_2D, },
  { (TfLiteIntArray*)&inputs10, (TfLiteIntArray*)&outputs10, const_cast<void*>(static_cast<const void*>(&opdata10)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs11, (TfLiteIntArray*)&outputs11, const_cast<void*>(static_cast<const void*>(&opdata11)), OP_ADD, },
  { (TfLiteIntArray*)&inputs12, (TfLiteIntArray*)&outputs12, const_cast<void*>(static_cast<const void*>(&opdata12)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs13, (TfLiteIntArray*)&outputs13, nullptr, OP_PAD, },
  { (TfLiteIntArray*)&inputs14, (TfLiteIntArray*)&outputs14, const_cast<void*>(static_cast<const void*>(&opdata14)), OP_DEPTHWISE_CONV_2D, },
  { (TfLiteIntArray*)&inputs15, (TfLiteIntArray*)&outputs15, const_cast<void*>(static_cast<const void*>(&opdata15)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs16, (TfLiteIntArray*)&outputs16, const_cast<void*>(static_cast<const void*>(&opdata16)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs17, (TfLiteIntArray*)&outputs17, const_cast<void*>(static_cast<const void*>(&opdata17)), OP_DEPTHWISE_CONV_2D, },
  { (TfLiteIntArray*)&inputs18, (TfLiteIntArray*)&outputs18, const_cast<void*>(static_cast<const void*>(&opdata18)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs19, (TfLiteIntArray*)&outputs19, const_cast<void*>(static_cast<const void*>(&opdata19)), OP_ADD, },
  { (TfLiteIntArray*)&inputs20, (TfLiteIntArray*)&outputs20, const_cast<void*>(static_cast<const void*>(&opdata20)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs21, (TfLiteIntArray*)&outputs21, const_cast<void*>(static_cast<const void*>(&opdata21)), OP_DEPTHWISE_CONV_2D, },
  { (TfLiteIntArray*)&inputs22, (TfLiteIntArray*)&outputs22, const_cast<void*>(static_cast<const void*>(&opdata22)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs23, (TfLiteIntArray*)&outputs23, const_cast<void*>(static_cast<const void*>(&opdata23)), OP_ADD, },
  { (TfLiteIntArray*)&inputs24, (TfLiteIntArray*)&outputs24, const_cast<void*>(static_cast<const void*>(&opdata24)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs25, (TfLiteIntArray*)&outputs25, const_cast<void*>(static_cast<const void*>(&opdata25)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs26, (TfLiteIntArray*)&outputs26, const_cast<void*>(static_cast<const void*>(&opdata26)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs27, (TfLiteIntArray*)&outputs27, const_cast<void*>(static_cast<const void*>(&opdata27)), OP_SOFTMAX, },
};
static std::vector<void*> overflow_buffers;
static void * AllocatePersistentBuffer(struct TfLiteContext* ctx,
                                       size_t bytes) {
  void *ptr;
  if (current_location - bytes < tensor_boundary) {
    // OK, this will look super weird, but.... we have CMSIS-NN buffers which
    // we cannot calculate beforehand easily.
    ptr = ei_calloc(bytes, 1);
    if (ptr == NULL) {
      printf("ERR: Failed to allocate persistent buffer of size %d\n", (int)bytes);
      return NULL;
    }
    overflow_buffers.push_back(ptr);
    return ptr;
  }

  current_location -= bytes;

  ptr = current_location;
  memset(ptr, 0, bytes);

  return ptr;
}
typedef struct {
  size_t bytes;
  void *ptr;
} scratch_buffer_t;
static std::vector<scratch_buffer_t> scratch_buffers;

static TfLiteStatus RequestScratchBufferInArena(struct TfLiteContext* ctx, size_t bytes,
                                                int* buffer_idx) {
  scratch_buffer_t b;
  b.bytes = bytes;

  b.ptr = AllocatePersistentBuffer(ctx, b.bytes);
  if (!b.ptr) {
    return kTfLiteError;
  }

  scratch_buffers.push_back(b);

  *buffer_idx = scratch_buffers.size() - 1;

  return kTfLiteOk;
}

static void* GetScratchBuffer(struct TfLiteContext* ctx, int buffer_idx) {
  if (buffer_idx > static_cast<int>(scratch_buffers.size()) - 1) {
    return NULL;
  }
  return scratch_buffers[buffer_idx].ptr;
}

static TfLiteTensor* GetTensor(const struct TfLiteContext* context,
                               int tensor_idx) {
  return &tflTensors[tensor_idx];
}

static TfLiteEvalTensor* GetEvalTensor(const struct TfLiteContext* context,
                                       int tensor_idx) {
  return &tflEvalTensors[tensor_idx];
}

} // namespace

TfLiteStatus trained_model_init( void*(*alloc_fnc)(size_t,size_t) ) {
#ifdef EI_CLASSIFIER_ALLOCATION_HEAP
  tensor_arena = (uint8_t*) alloc_fnc(16, kTensorArenaSize);
  if (!tensor_arena) {
    printf("ERR: failed to allocate tensor arena\n");
    return kTfLiteError;
  }
#else
  memset(tensor_arena, 0, kTensorArenaSize);
#endif
  tensor_boundary = tensor_arena;
  current_location = tensor_arena + kTensorArenaSize;
  ctx.AllocatePersistentBuffer = &AllocatePersistentBuffer;
  ctx.RequestScratchBufferInArena = &RequestScratchBufferInArena;
  ctx.GetScratchBuffer = &GetScratchBuffer;
  ctx.GetTensor = &GetTensor;
  ctx.GetEvalTensor = &GetEvalTensor;
  ctx.tensors = tflTensors;
  ctx.tensors_size = 72;
  for(size_t i = 0; i < 72; ++i) {
    tflTensors[i].type = tensorData[i].type;
    tflEvalTensors[i].type = tensorData[i].type;
    tflTensors[i].is_variable = 0;

#if defined(EI_CLASSIFIER_ALLOCATION_HEAP)
    tflTensors[i].allocation_type = tensorData[i].allocation_type;
#else
    tflTensors[i].allocation_type = (tensor_arena <= tensorData[i].data && tensorData[i].data < tensor_arena + kTensorArenaSize) ? kTfLiteArenaRw : kTfLiteMmapRo;
#endif
    tflTensors[i].bytes = tensorData[i].bytes;
    tflTensors[i].dims = tensorData[i].dims;
    tflEvalTensors[i].dims = tensorData[i].dims;

#if defined(EI_CLASSIFIER_ALLOCATION_HEAP)
    if(tflTensors[i].allocation_type == kTfLiteArenaRw){
      uint8_t* start = (uint8_t*) ((uintptr_t)tensorData[i].data + (uintptr_t) tensor_arena);

     tflTensors[i].data.data =  start;
     tflEvalTensors[i].data.data =  start;
    }
    else{
       tflTensors[i].data.data = tensorData[i].data;
       tflEvalTensors[i].data.data = tensorData[i].data;
    }
#else
    tflTensors[i].data.data = tensorData[i].data;
    tflEvalTensors[i].data.data = tensorData[i].data;
#endif // EI_CLASSIFIER_ALLOCATION_HEAP
    tflTensors[i].quantization = tensorData[i].quantization;
    if (tflTensors[i].quantization.type == kTfLiteAffineQuantization) {
      TfLiteAffineQuantization const* quant = ((TfLiteAffineQuantization const*)(tensorData[i].quantization.params));
      tflTensors[i].params.scale = quant->scale->data[0];
      tflTensors[i].params.zero_point = quant->zero_point->data[0];
    }
    if (tflTensors[i].allocation_type == kTfLiteArenaRw) {
      auto data_end_ptr = (uint8_t*)tflTensors[i].data.data + tensorData[i].bytes;
      if (data_end_ptr > tensor_boundary) {
        tensor_boundary = data_end_ptr;
      }
    }
  }
  if (tensor_boundary > current_location /* end of arena size */) {
    printf("ERR: tensor arena is too small, does not fit model - even without scratch buffers\n");
    return kTfLiteError;
  }
  registrations[OP_CONV_2D] = Register_CONV_2D();
  registrations[OP_DEPTHWISE_CONV_2D] = Register_DEPTHWISE_CONV_2D();
  registrations[OP_ADD] = Register_ADD();
  registrations[OP_PAD] = Register_PAD();
  registrations[OP_SOFTMAX] = Register_SOFTMAX();

  for(size_t i = 0; i < 28; ++i) {
    tflNodes[i].inputs = nodeData[i].inputs;
    tflNodes[i].outputs = nodeData[i].outputs;
    tflNodes[i].builtin_data = nodeData[i].builtin_data;
tflNodes[i].custom_initial_data = nullptr;
      tflNodes[i].custom_initial_data_size = 0;
if (registrations[nodeData[i].used_op_index].init) {
      tflNodes[i].user_data = registrations[nodeData[i].used_op_index].init(&ctx, (const char*)tflNodes[i].builtin_data, 0);
    }
  }
  for(size_t i = 0; i < 28; ++i) {
    if (registrations[nodeData[i].used_op_index].prepare) {
      TfLiteStatus status = registrations[nodeData[i].used_op_index].prepare(&ctx, &tflNodes[i]);
      if (status != kTfLiteOk) {
        return status;
      }
    }
  }
  return kTfLiteOk;
}

static const int inTensorIndices[] = {
  0, 
};
TfLiteTensor* trained_model_input(int index) {
  return &ctx.tensors[inTensorIndices[index]];
}

static const int outTensorIndices[] = {
  71, 
};
TfLiteTensor* trained_model_output(int index) {
  return &ctx.tensors[outTensorIndices[index]];
}

TfLiteStatus trained_model_invoke() {
  for(size_t i = 0; i < 28; ++i) {
    TfLiteStatus status = registrations[nodeData[i].used_op_index].invoke(&ctx, &tflNodes[i]);

#if EI_CLASSIFIER_PRINT_STATE
    ei_printf("layer %lu\n", i);
    ei_printf("    inputs:\n");
    for (size_t ix = 0; ix < tflNodes[i].inputs->size; ix++) {
      auto d = tensorData[tflNodes[i].inputs->data[ix]];

      size_t data_ptr = (size_t)d.data;

      if (d.allocation_type == kTfLiteArenaRw) {
        data_ptr = (size_t)tensor_arena + data_ptr;
      }

      if (d.type == TfLiteType::kTfLiteInt8) {
        int8_t* data = (int8_t*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes; jx++) {
          ei_printf("%d ", data[jx]);
        }
      }
      else {
        float* data = (float*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes / 4; jx++) {
          ei_printf("%f ", data[jx]);
        }
      }
      ei_printf("\n");
    }
    ei_printf("\n");

    ei_printf("    outputs:\n");
    for (size_t ix = 0; ix < tflNodes[i].outputs->size; ix++) {
      auto d = tensorData[tflNodes[i].outputs->data[ix]];

      size_t data_ptr = (size_t)d.data;

      if (d.allocation_type == kTfLiteArenaRw) {
        data_ptr = (size_t)tensor_arena + data_ptr;
      }

      if (d.type == TfLiteType::kTfLiteInt8) {
        int8_t* data = (int8_t*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes; jx++) {
          ei_printf("%d ", data[jx]);
        }
      }
      else {
        float* data = (float*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes / 4; jx++) {
          ei_printf("%f ", data[jx]);
        }
      }
      ei_printf("\n");
    }
    ei_printf("\n");
#endif // EI_CLASSIFIER_PRINT_STATE

    if (status != kTfLiteOk) {
      return status;
    }
  }
  return kTfLiteOk;
}

TfLiteStatus trained_model_reset( void (*free_fnc)(void* ptr) ) {
#ifdef EI_CLASSIFIER_ALLOCATION_HEAP
  free_fnc(tensor_arena);
#endif
  scratch_buffers.clear();
  for (size_t ix = 0; ix < overflow_buffers.size(); ix++) {
    free(overflow_buffers[ix]);
  }
  overflow_buffers.clear();
  return kTfLiteOk;
}
